%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% rename(+TPTPData, +Renaming, -RenamedData):
% ===========================================
% TPTPData: Eingegebene TPTP-Klausenmenge
% Renaming: Vorschrift zur Umbenennung der Klausen
% RenamedData: Umbenannte Klausen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

rename_clause(input_clause(X, Y, []), _Renaming, input_clause(X, Y, [])).
rename_clause(input_clause(X, Y, [Literal | Literals]), Renaming, 
	      input_clause(X, Y, [RenamedLiteral | RenamedLiterals])):-
    rename_literal(Literal, Renaming, RenamedLiteral),
    rename_clause(input_clause(X, Y, Literals), Renaming, 
		  input_clause(X, Y, RenamedLiterals)).
rename_clause(include(X), _, include(X)).

rename_literal(++Atom, Renaming, --Atom):-
    functor(Atom, PS, _),
    member(++PS, Renaming),
    !.
rename_literal(++Atom, _Renaming, ++Atom).

rename_literal(--Atom, Renaming, ++Atom):-
    functor(Atom, PS, _),
    member(++PS, Renaming),
    !.
rename_literal(--Atom, _Renaming, --Atom).

