
% mb.pl
%
% loads all predicates implementing the completion procedure for term rewriting
% systems via a metainterpreter and
% all predicates necessary for clause evaluation.

:- op(500,fx,++).
:- op(500,fx,--).

:- ['others/general.pl'].                  % general predicates
:- ['others/term.pl'].
:- ['others/queue.pl'].

:- ['trs_mi/mi_datastr.pl'].               % definitions of datastructures
:- ['trs_mi/mi_var.pl'].
:- ['trs_mi/mi_rep.pl'].

:- ['others/order.pl'].                   % orderings
:- ['trs_mi/mi_ford.pl'].
:- ['trs_mi/mi_size.pl'].
:- ['trs_mi/mi_emb.pl'].
:- ['trs_mi/mi_lebg.pl'].
:- ['others/depthOrd.pl'].

:- ['others/sort.pl'].                     % quicksort 
:- ['trs_mi/mi_sort.pl'].                  % and predicates to handle the databases
:- ['trs_mi/mi_pdb.pl'].                   

:- ['trs_mi/mi_unif.pl'].                  % technical parts
:- ['trs_mi/mi_rord.pl'].
:- ['trs_mi/mi_cps.pl'].

:- ['trs_mi/mi_step.pl'].                  % metainterpreter
:- ['trs_mi/mi_idj.pl'].

:- ['trs_mi/mi_data.pl'].                  % completion procedure
:- ['trs_mi/mi_compl.pl'].

:- ['mb/tptp_parser.pl'].             % tptp dcg parser
:- ['mb/cl_eval.pl'].
