
% mi_ford.pl
%
% ordering of function symbols via a list of function weights

:- module(mi_ford,[funcOrd/3,weight/3]).

% funcOrd(Weights,F,G) <-- 
%                     is true if theweight of function symbol X is greater or equal
%                     than the weight of function symbol Y
%                     Weights is the list of function symbol weights

funcOrd(Weights,F,G) :-
   weight(F,Weights,Weight_F),
   weight(G,Weights,Weight_G),
   Weight_F > Weight_G.

% weight(FunSym,Weights,Weight) <-- Weight is the weight of FunSym

weight(F,[(F=Weight)|_],Weight).
weight(F,[_|Weights],Weight) :-
   weight(F,Weights,Weight).

:- funcOrd([(f=2),(g=1)],f,g).
