#! /usr/bin/sh

oldIFS="$IFS"
IFS=":"
path=`echo $PATH`
IFS="$oldIFS"
path="$path /usr/local/bin /usr/local/sbin /usr/bin /usr/sbin /bin /sbin"
ucmds="false true cp mv pwd rm tar gzip"
binaries="python spass otter2 pl sicstus"
directories="top standard exper finmodel cleval TPTP2X examples"
tiltfiles="tilt Readme install.sh"

set_cmd(){
  for c in $*
  do
    notfound=$true
    for p in $path
    do
      if [ -x $p/$c ]
      then
        eval $c=$p/$c
        notfound=$false
        break
      fi
    done
    if $notfound
    then
      eval $c=$c
      return 1
    fi
  done
  return 0
}

read_dir(){
  while $true
  do
    eval echo -n \"Directory for $1 [\$$2]: \"
    read a
    a=`echo $a | $sed 's|~|'$HOME'|;s|$HOME|'$HOME'|'`
    if [ ! "$a" ]
    then
      eval a=\$$2
    fi
    if (echo $a | $grep -q '^/')
    then
      :
    else
      a=`$pwd`/$a
    fi
    if [ -d $a ]
    then
      eval $2=$a
      break
    else
      echo "    Create directory $a"
      mkdir $a
      eval $2=$a
      break
    fi
  done
}

# Searching for some Unix commands
if set_cmd $ucmds
then
  :
else
  echo "Error: could not find Unix command $c."
  exit 1
fi

tilt_inst=`@pwd`
cd $tilt_inst

tilt_src="/home/public/www/models/tilt/"

readdir 'TILT src directory" tilt_src

for c in $directories
do
    clean
done

$tar cvf tilt-v01.tar *
$gzip tilt-v01.tar 
$mv tilt-v01.tar.gz $tilt_src/tilt-v01.tgz

cd ..
$rm -rf $tilt_inst

echo ""
echo "Deinstalling done"


