%--------------------------------------------------------------------------
% File     : GRP081-1 : TPTP v2.0.0. Released v1.0.0.
% Domain   : Group Theory
% Problem  : Single axiom for group theory, in double division and inverse
% Version  : [McCune, 1993] (equality) axioms.
% English  : This is a single axiom for group theory, in terms of double 
%            division and inverse.

% Refs     : Neumann B.H. (1986), Yet another single law for groups, 
%            Illinois Journal of Mathematics 30(2), 295-300.
%          : McCune W.W. (1993), Single Axioms for Groups and Abelian 
%            Groups with Various Operations, Journal of Automated 
%            Reasoning 10(1), 1-13.
% Source   : [McCune, 1993]
% Names    : Axiom 2.5 [McCune, 1993]

% Status   : unknown
% Rating   : 1.00 v2.0.0
% Syntax   : Number of clauses    :   11 (   0 non-Horn;   3 unit;   4 RR)
%            Number of literals   :   21 (  21 equality)
%            Maximal clause size  :    3 (   1 average)
%            Number of predicates :    1 (   0 propositional; 2-2 arity)
%            Number of functors   :   10 (   7 constant; 0-2 arity)
%            Number of variables  :   26 (   0 singleton)
%            Maximal term depth   :    9 (   1 average)

% Comments : Thought to be satisfiable.
%--------------------------------------------------------------------------
%----Include Reflexivity, symmetry and transitivity, of equality 
include('Axioms/EQU001-0.ax').
%--------------------------------------------------------------------------
input_clause(single_axiom,axiom,
    [++equal(inverse(double_divide(double_divide(X,double_divide(
double_divide(Y,Z),inverse(double_divide(Y,double_divide(inverse(U),
inverse(Z)))))),X)),U)]).

%----Definition of double division 
input_clause(double_division,axiom,
    [++equal(double_divide(X,Y),multiply(inverse(X),inverse(Y)))]).

%----Substitution axioms 
input_clause(inverse_substitution,axiom,
    [--equal(X,Y),
     ++equal(inverse(X),inverse(Y))]).

input_clause(multiply_substitution1,axiom,
    [--equal(X,Y),
     ++equal(multiply(X,W),multiply(Y,W))]).

input_clause(multiply_substitution2,axiom,
    [--equal(X,Y),
     ++equal(multiply(W,X),multiply(W,Y))]).

input_clause(double_divide_substitution1,axiom,
    [--equal(X,Y),
     ++equal(double_divide(X,W),double_divide(Y,W))]).

input_clause(double_divide_substitution2,axiom,
    [--equal(X,Y),
     ++equal(double_divide(W,X),double_divide(W,Y))]).

input_clause(prove_these_axioms,conjecture,
    [--equal(multiply(inverse(a1),a1),multiply(inverse(b1),b1)),
     --equal(multiply(multiply(inverse(b2),b2),a2),a2),
     --equal(multiply(multiply(a3,b3),c3),multiply(a3,multiply(b3,c3)))]).
%--------------------------------------------------------------------------
