%--------------------------------------------------------------------------
% File     : PUZ028-1 : TPTP v2.1.0. Released v1.0.0.
% Domain   : Puzzles
% Problem  : People at a party
% Version  : Special.
% English  : We can always choose 3 persons who are either familiar with 
%            each other or not familiar with each other, from 6 persons 
%            who meet at a party.

% Refs     : [ICO92] ICOT (1992), Model Generation Theorem Prover, MGTP
% Source   : [TPTP]
% Names    : 

% Status   : satisfiable
% Rating   : 0.33 v2.1.0, 0.00 v2.0.0
% Syntax   : Number of clauses    :   15 (   1 non-Horn;  11 unit;  15 RR)
%            Number of literals   :   25 (   0 equality)
%            Maximal clause size  :    5 (   1 average)
%            Number of predicates :    4 (   0 propositional; 1-2 arity)
%            Number of functors   :    6 (   6 constant; 0-0 arity)
%            Number of variables  :   11 (   0 singleton)
%            Maximal term depth   :    1 (   1 average)

% Comments : Adapted from [ICO92]
%          : This version is satisfiable because of the argument order in
%            the theorem clauses. We can assume that familiarity is meant
%            symmetrically, but only established in one direction by the
%            after/2 contstraint in familiar_or_not. So really this is
%            wrong, and is corrected in PUZ028-5.
%--------------------------------------------------------------------------
input_clause(person1,axiom,
    [++person(one)]).

input_clause(person2,axiom,
    [++person(two)]).

input_clause(person3,axiom,
    [++person(three)]).

input_clause(person4,axiom,
    [++person(four)]).

input_clause(person5,axiom,
    [++person(five)]).

input_clause(person6,axiom,
    [++person(six)]).

input_clause(order1,axiom,
    [++after(one,two)]).

input_clause(order2,axiom,
    [++after(two,three)]).

input_clause(order3,axiom,
    [++after(three,four)]).

input_clause(order4,axiom,
    [++after(four,five)]).

input_clause(order5,axiom,
    [++after(five,six)]).

input_clause(transitivity_of_order,axiom,
    [++after(Large,Small),
     --after(Large,Medium),
     --after(Medium,Small)]).

input_clause(familiar_or_not,axiom,
    [++familiar(X,Y),
     ++not_familiar(X,Y),
     --person(X),
     --person(Y),
     --after(X,Y)]).

%----These 3 literals can never all be resolved away because the
%----familiar_or_not axiom prevents X1 > X2 > X3 > X1, as is
%----required by the argument ordering here. That's why it's
%----satisfiable.
input_clause(three_familiar,conjecture,
    [--familiar(X1,X2),
     --familiar(X2,X3),
     --familiar(X3,X1)]).

input_clause(three_not_familiar,conjecture,
    [--not_familiar(X1,X2),
     --not_familiar(X2,X3),
     --not_familiar(X3,X1)]).
%--------------------------------------------------------------------------
