%--------------------------------------------------------------------------
% File     : PUZ028-5 : TPTP v2.1.0. Released v2.0.0.
% Domain   : Puzzles
% Problem  : People at a party
% Version  : [ICO92] axioms : Special.
% English  : We can always choose 3 persons who are either familiar with 
%            each other or not familiar with each other, from 6 persons 
%            who meet at a party.

% Refs     : [ICO92] ICOT (1992), Model Generation Theorem Prover, MGTP
%          : [Gei95] Geisler (1995), Email to C. Suttner
% Source   : [TPTP]
% Names    : 

% Status   : unsatisfiable
% Rating   : 0.33 v2.1.0
% Syntax   : Number of clauses    :   15 (   1 non-Horn;  11 unit;  15 RR)
%            Number of literals   :   25 (   0 equality)
%            Maximal clause size  :    5 (   1 average)
%            Number of predicates :    4 (   0 propositional; 1-2 arity)
%            Number of functors   :    6 (   6 constant; 0-0 arity)
%            Number of variables  :   11 (   0 singleton)
%            Maximal term depth   :    1 (   1 average)

% Comments : The version in [ICO92] gets the order of arguments in
%            the theorem clauses wrong, and is satisfiable as a result.
%            The intention was clearly to proof the statement given above 
%            in the % English field. This version corrects it. The TUM
%            versions of this problem suffer the same fate as the ICOT
%            versions. Tim Geisler [Gei95] pointed this out.
%--------------------------------------------------------------------------
input_clause(person1,axiom,
    [++person(one)]).

input_clause(person2,axiom,
    [++person(two)]).

input_clause(person3,axiom,
    [++person(three)]).

input_clause(person4,axiom,
    [++person(four)]).

input_clause(person5,axiom,
    [++person(five)]).

input_clause(person6,axiom,
    [++person(six)]).

input_clause(order1,axiom,
    [++after(one,two)]).

input_clause(order2,axiom,
    [++after(two,three)]).

input_clause(order3,axiom,
    [++after(three,four)]).

input_clause(order4,axiom,
    [++after(four,five)]).

input_clause(order5,axiom,
    [++after(five,six)]).

input_clause(transitivity_of_order,axiom,
    [++after(Large,Small),
     --after(Large,Medium),
     --after(Medium,Small)]).

input_clause(familiar_or_not,axiom,
    [++familiar(X,Y),
     ++not_familiar(X,Y),
     --person(X),
     --person(Y),
     --after(X,Y)]).

input_clause(three_familiar,conjecture,
    [--familiar(X1,X2),
     --familiar(X2,X3),
     --familiar(X1,X3)]).

input_clause(three_not_familiar,conjecture,
    [--not_familiar(X1,X2),
     --not_familiar(X2,X3),
     --not_familiar(X1,X3)]).
%--------------------------------------------------------------------------
