%
%	Compatibility declarations for SICSTUS prolog
%

% operator =@= (strukturelle identitaet)

:- module(compatibility, [struct_identical/2,
	meta_select/3,
	flatten/2,
	substract/3,
	union/3,
	list_to_set/2,
	maplist/3,
	apply/2]).

?- use_module(library(system)).
?- use_module(library(lists)).
?- use_module(library(ordsets)).

struct_identical([],[]).
struct_identical([A|As],[B|Bs]) :-
	var(A),var(B),!,
	struct_identical(As,Bs).
struct_identical([A|As],[B|Bs]) :-
	\+ var(A),
	\+ var(B),
	A =.. [F|L1],
	B =.. [F|L2],
	struct_identical(L1,L2),
	struct_identical(As,Bs).


% shell(X) :- unix(shell(X)).


meta_select(A,B,C) :-
	select(B,A,C).


flatten([],[]).
flatten([[A|As]|Bs], Cs) :-
	flatten(Bs,X),
	append(As,X,Y),
	Cs = [A|Y].


subtract(A,B,C) :- ord_subtract(A,B,C).
list_to_set(A,B) :- list_to_ord_set(A,B).
union(A,B,C) :- ord_union(A,B,C).



% maplist predicate

maplist(_,[],[]).
maplist(Prefix,[L|Ls],[R|Rs]) :-
	apply(Prefix,[L,R]),
	maplist(Prefix,Ls,Rs).

apply(Prefix, Args) :-
	Prefix =.. [F|PreArgs],
	append(PreArgs,Args,AllArgs),
	Term =.. [F|AllArgs],
	call(user:Term).

