:- [mb].
davis_putnam(Cs0, M):-
    split(Cs0, Cs1),
    saturate(Cs1, [], M0),
    list_to_set(M0, M).

split([C|Cs], [[D]|Cs]):-
    member(D, C).
split([C|Cs], [C|Ds]):-
    split(Cs, Ds).

saturate(Cs0, M0, M):-
    reduce(Cs0, Cs0, M0, M), % Wenn sich bei der Reduktion nichts ndert,
    !.                       % ist das Verfahren fertig
saturate(Cs0, M0, M):-
    reduce(Cs0, Cs1, M0, M1),
    saturate(Cs1, M1, M).

reduce(Cs0, Ds, M0, M):-
    remove_tautologies(Cs0, Cs1),      % Lsche alle Tautologien
    remove_unit_clauses(Cs1, Cs2, M1), % Lsche alle Einheitsklausen [L]
                                       % sowie alle Klausen, in denen
                                       % L vorkommt, sammle die L in M1.
                                       % Entferne aus allen Nicht-Einheits-
                                       % Klausen L^d
                                       % Falls Einheitsklause [L^d] auftritt,
                                       % ist Prdikat nicht erfllbar!
    remove_pure_literals(Cs2, Ds, M2), % Lsche alle Klausen, die 
                                       % pure Literale enthalten
    append(M0, M1, M3),
    append(M3, M2, M).












