%------------------------------------------------------
% run classification and arm computation
%
% input: problem-file in tptp-syntax
% output: arm\
%
%------------------------------------------------------

:- assertz(user:file_search_path(standard,'.')).

/* fuer die settings */
?- op(500, fx, ++).
?- op(500, fx, --).
% fuer rules
?- op(640, xfx, =>).

%?- ensure_loaded('classify.pl').
?- ensure_loaded(standard(arm_tilt)).

add_reflexivity(F) :-
	open(F, append, F1),
	nl(F1),
	write(F1, '% reflexivity axiom'),
	nl(F1),
	write(F1, 'input_clause(reflexivity, axiom, [++equal(A, A)]).'),
	close(F1).
	

standardMB(F_renamed, Type) :-
	write('*** AUTOMATED MODEL BUILDING EMPLOYING AN OTTER-ADAPTION'), nl,
%	classify(F, F_renamed, Type),
	( Type == pvd  -> 
	write(' problem-class: pvd.'), nl ; true ),
	( Type == pvdeq  -> 
	add_reflexivity(F_renamed),
	write(' problem-class: pvdeq.'), nl ; true ),
	( Type == unknown  -> 
	write(' problem-class: unknown.'), nl, 
		write('WARNING: algorithms probably incorrect for this problem!'), nl
	; true ),
	write('*** arm computation started'), nl, nl,
	arm(F_renamed).
