#!/usr/local/bin/python
import sys
import os
import string
import regsub
import tkMessageBox

###########################################################################################
###########################################################################################
##													##
##	GIVES VARIABLES UNIFORM NAMES								##
##			classes:										##
##				BeautyVars								##
##													##
###########################################################################################
###########################################################################################

class BeautyVars:
##########################################################################################
#	Given a model-file excahanges variablenames for uniform variablenames					#
#		Modelfile: 	[++a(X,Y,Z)]								#
#				[++b(X)]									#
#				[++c(W,Z,Y)]								#
#				...									#
#													#
#		methods:										#
#			__init__(self,filename) ... does the whole thing					#
#			make_number(self) ... from self.nextVar computes and returns String 			#
#			control(self,change) ... checks the change-dictionary					#
##########################################################################################
	def __init__(self,filename):
	###################################################################################
	#	reads filename and gets variable-names, computes dictionary of changes, 			#
	#	changes variable names and writes 'new' clauses to filename					#
	###################################################################################
		f = open(filename)
		lines = f.readlines()
		f.close()
		numOfLines = len(lines)
		x={}
		self.nextVar=0
		change={}
		try:
			for i in range(numOfLines):
		#	get variable-names
									#	lines[i-1]="[++a(X,Y,Z)]"
				x0=string.splitfields(lines[i-1],"(")		#	x0=["[++a","X,Y,Z)]"]
				x1=string.splitfields(x0[1],")")		# 	x1=["X,Y,Z","]"]
				x2=string.splitfields(x1[0],",")		#	x2=["X","Y","Z"]
				numOfVars=len(x2)
		#	make dictionary (X-->X000, Y->X001, Z->X002,...)
				for k in range(numOfVars):
					if x2[k-1] in change.keys():
						pass
					else:
						change[x2[k-1]]="X"+self.make_number()
						self.nextVar=self.nextVar+1
			ret,change=self.control(change)
			while ret=="ERROR":
				ret,change=self.control(change)
		#	change variable-names and write to file
			f = open(filename,"w")
			for i in range(numOfLines):				
				for j in change.keys():
					lines[i-1]=regsub.gsub(j+",",change[j]+",",lines[i-1])
					lines[i-1]=regsub.gsub(j+")",change[j]+")",lines[i-1])
				f.write(lines[i-1])
			f.close()
		except:
			tkMessageBox.showerror("File","Error in Model-File - wrong format \n" + filename)

	def make_number(self):
				if self.nextVar<10:
					return "00"+str(self.nextVar)
				elif self.nextVar<100:
					return "0"+str(self.nextVar)
				else:
					return str(self.nextVar)

	def control(self,change):
		#	checks dictionary for 'circles' (X->X001,X001->X002)
		ret="OK"
		for i in change.keys():
			if change[i] in change.keys():
				ret="ERROR"
				change[i]="X"+self.make_number()
				self.nextVar=self.nextVar+1
		return ret,change