from Tkinter import *
from ScrolledText import ScrolledText

class ClauseEditor:
	"""presents a dialog in which the user can choose a name,
	type and the contents of a tptp-clause.
	usage:
		ef = ClauseEditor(self, numberOfLines)
		name, type, fla = ef.show()"""

	def __init__(self, parent=None, num=0, clause=None):
		"""Prepares the new window (Toplevel) for
		presentation. parent is not yet necessary."""

		self.top = Toplevel()
		self.top.withdraw()
		frame = Frame(self.top)
		frame.pack()

		self.clause_name = StringVar()
		if clause:
			self.clause_name.set(clause[0])
		else:
			self.clause_name.set("formula_"+`num`)

		self.type = StringVar()
		if clause:
			self.type.set(clause[1])
		else:
			self.type.set("hypothesis")

		# Namen der Klause festlegen
		label1 = Label(frame, text="Name:")
		label1.grid(row=0, column=0,padx=2, pady=2)
		name = Entry(frame, textvariable=self.clause_name)
		name.grid(row=0, column=1)

		#Typ der Klause festlegen
		label2 = Label(frame, text="Type:",padx=2, pady=2)
		label2.grid(row=1, column=0)
		type = OptionMenu(frame, self.type,"axiom", 
				"conjecture", "hypothesis")
		type.grid(row=1, column=1)

		# Inhalt der Klause festlegen
		label3 = Label(frame, text="Contents:",padx=2, pady=2)
		label3.grid(row=2, column=0)
		""" # That f***ing Tkinter does not present the dialog
			# when I try to insert a ScrolledText!
			# No idea, why!
		if clause:
			max = 0
			lines = string.splitfields(clause[2], '\n')
			for line in lines:
				if len(line) > max:
					max = len(line)
			print "Width:", max, "Height:", len(lines) 
			self.contents = ScrolledText(frame, width=max, 
					height=len(lines), relief='sunken')
			#contents=Entry(frame) 
			#contents.insert('0,0', clause[2]) 
		else:
			self.contents = ScrolledText(frame, width=30, height=4,
					relief='sunken')
			#contents=Entry(frame)
			print "Width:", 30, "Height:",4
		"""
		self.contents = StringVar()
		if clause:
			self.contents.set(clause[2])
		contents=Entry(frame, textvariable = self.contents)
		contents.grid(row=2, column=1)

		button = Button(frame, text="OK", 
				command = self.top.destroy)
		button.grid(row=3, column=1)

	def show(self):
		""" shows the dialog and waits for the user to
		terminate it again (wait_window). returns the
		name, type and contents of the clause"""

		self.top.deiconify()
		self.top.wait_window()
		return self.clause_name.get(), self.type.get(),	self.contents.get()
		
if __name__ == "__main__":
	c = ClauseEditor()
	(x,y,z) =  c.show()
	print x,y,z

	d = ClauseEditor(None, 5)
	(x,y,z) = d.show()
	print x,y,z

	e = ClauseEditor(None, 3, ("My_Name", "My_Type", "[a,\nb, c]"))
	(x,y,z) = e.show()
	print x,y,z
