from Tkinter import *
from ScrolledText import ScrolledText
import string

class ClauseEditor:
	"""presents a dialog in which the user can choose a name,
	type and the contents of a tptp-clause.
	usage:
		ef = ClauseEditor(self, numberOfLines)
		name, type, fla = ef.show()"""

	def __init__(self, parent=None, num=0, clause=None):
		"""Prepares the new window (Toplevel) for
		presentation. parent is not yet necessary."""

		self.top = Toplevel()
		self.top.withdraw()
		frame = Frame(self.top)
		frame.pack(expand=1, fill=BOTH)

		self.clause_name = StringVar()
		if clause:
			self.clause_name.set(clause[0])
		else:
			self.clause_name.set("formula_"+`num`)

		self.type = StringVar()
		if clause:
			self.type.set(clause[1])
		else:
			self.type.set("hypothesis")

		frame1 = Frame(frame)
		# Namen der Klause festlegen
		label1 = Label(frame1, text="Name:")
		label1.grid(row=0, column=0,padx=2, pady=2)
		name = Entry(frame1, textvariable=self.clause_name)
		name.grid(row=0, column=1)

		#Typ der Klause festlegen
		label2 = Label(frame1, text="Type:",padx=2, pady=2)
		label2.grid(row=1, column=0)
		type = OptionMenu(frame1, self.type,"axiom", 
				"conjecture", "hypothesis")
		type.grid(row=1, column=1)
		frame1.pack()

		frame2=Frame(frame)
		frame2.pack(side=BOTTOM, expand=1, fill=BOTH)
		# Inhalt der Klause festlegen
		label3 = Label(frame2, text="Contents:",padx=2, pady=2)
		label3.pack(side=LEFT)
		# That f***ing Tkinter does not present the dialog
			# when I try to insert a ScrolledText!
			# No idea, why!
		self.contents=StringVar()
		if clause:
			max = 0
			lines = string.splitfields(clause[2], '\n')
			for line in lines:
				if len(line) > max:
					max = len(line)
			print "Width:", max, "Height:", len(lines) 
#			self.contents = ScrolledText(frame, width=max, 
#					height=len(lines), relief='sunken')
			contents = Entry(frame,textvariable=self.contents)
		else:
#			self.contents = ScrolledText(frame2, width=70, height=10,
#					relief='sunken')
			contents = Entry(frame2, textvariable=self.contents)
		if clause:
			self.contents.set(clause[2])
		contents.pack(side=RIGHT, expand=1, fill=BOTH)
		button = Button(frame, text="OK", 
				command = self.top.destroy)
		button.pack(side=BOTTOM)

	def show(self):
		""" shows the dialog and waits for the user to
		terminate it again (wait_window). returns the
		name, type and contents of the clause"""

		self.top.deiconify()
		self.top.wait_window()
		return self.clause_name.get(), self.type.get(), self.contents.get()
		
if __name__ == "__main__":
	c = ClauseEditor()
	(x,y,z) =  c.show()
	print x,y,z

	d = ClauseEditor(None, 5)
	(x,y,z) = d.show()
	print x,y,z

	e = ClauseEditor(None, 3, ("My_Name", "My_Type", "[a,\nb, c]"))
	(x,y,z) = e.show()
	print x,y,z










