import string

class Component:
    def __init__(self, lines):
	self.contents = lines[0]

    def __repr__(self):
	return self.contents

    def config(self, tuple):
        self.contents = tuple[0] + "\n"

    def get_description(self):
		return (("Component", self.contents),)

    def is_comment(self):
	return 0

    def get_num_of_lines(self):
	return 1
 
class TPTPClause(Component):

    def __init__(self, lines):
	s = ''
	print "Lines: ", lines
	s = lines[0]
	for line in lines[1:]:
	    s = s + line
	name_start = string.find(s, "(")
	type_start = string.find(s, ",")
	type_end = string.find(s, ",", type_start+1)
	contents_start = string.find(s, "[")
	contents_end = string.find(s, "]")
	self.name = string.strip(s[name_start+1:type_start])
	self.type = string.strip(s[type_start+1:type_end])
	self.contents = string.strip(s[contents_start+1:
				       contents_end])
	splittedLine = string.splitfields(`self`, "\n")
	self.numOfLines = len(splittedLine) - 1 # ignore trailing \n!

    def config(self, tuple):
        self.name=tuple[0]
	self.type=tuple[1]
	self.contents=tuple[2]
	self.numOfLines=2

    def __repr__(self):
	result = "input_clause(" + self.name + ", " + \
		self.type + \
		 ",\n    [" + self.contents + "]).\n"
	return result

    def get_description(self):
	return ("Name", self.name), ("Type", self.type), \
		("Contents", self.contents)

    def get_num_of_lines(self):
	return self.numOfLines

class TPTPInclude(Component):

    def __init__(self, lines):
        line = lines[0]
	idx = string.find(line, "'")
	idx2 = string.find(line, "'", idx+1)
	self.contents = line[idx:idx2]

    def config(self, tuple):
        self.contents=tuple[0]

    def __repr__(self):
	return "include('" + self.contents + "').\n"

    def get_description(self):
	return (("Include file", self.contents),)

class Comment(Component):

    def __init__(self, lines):
    	start = string.find(lines[0], "%")
	self.contents = lines[0][start+1:]

    def config(self, tuple):
        self.contents=tuple[0]+"\n"

    def __repr__(self):
	return "% " + self.contents

    def get_description(self):
	comm_idx = string.find(self.contents, "%")
	return (("Comment", self.contents[comm_idx+1:]),)

    def is_comment(self):
		return 1

class Other(Component):

    def __init__(self, lines):
	self.contents = lines[0]

    def config(self, tuple):
        self.contents=tuple[0] + "\n"
		
    def __repr__(self):
	return self.contents

    def get_description(self):
	return (("Other", self.contents),)

class SPASSClause(Component):

    def __init__(self, lines):
	s = ''
	for line in lines:
	    s = s + line
	start = string.find(s, "(")
	end = string.rfind(s, ")")
	self.contents=s[start:end]
	self.prefix = s[:start]
	splittedLine = string.splitfields(`self`, "\n")
	self.numOfLines = len(splittedLine) - 1 # ignore trailing \n!

    def config(self, tuple):
        self.contents=tuple[0]
	self.prefix="  clause"
	self.numOfLines=1
	
    def __repr__(self):
	return self.prefix + self.contents + ").\n"

    def get_description(self):
	return (("Clause", self.contents), )
	
    def get_num_of_lines(self):
	return self.numOfLines

class OtterExpression(Component):
    def __init__(self, lines):
	print lines
	self.contents = string.joinfields(lines, "")
	self.numOfLines = len(lines)

    def config(self, tuple):
        self.contents=tuple[0]+"\n"
        self.numOfLines=1
	
    def __repr__(self):
	return self.contents
	
    def get_description(self):
	return (("Expression", self.contents), )
	
    def get_num_of_lines(self):
	return self.numOfLines
