import string
import compon

class File:
    def __init__(self, lines):
	self.lines = lines
	self.components = self._extract_components()
	self.current_line = 1
	self.curr_idx = 0
	self.names = {}
	self.types = ()

    def _extract_components(self):
	components = []
	for line in self.lines:
	    components.append(compon.Component([line]))
	return components
	    
    def __repr__(self):
	result = ""
	for component in self.components:
	    result = result + str(component)
	return result

    def get_current_description(self):
	return self.components[self.curr_idx].get_description()

    def get_current_delimiters(self):
	start = `self.current_line` + ".0"
	end_of_component = self.current_line + \
		      self.components[self.curr_idx].get_num_of_lines() - 1
	end = `end_of_component` + ".end"
	return start, end

    def get_free_name(self, name):
	if self.names.has_key(name):
	    self.names[name] = self.names[name] + 1
	else:
	    self.names[name] = 0
	return name + "_" + `self.names[name]`
	    
    def go_down(self):
	if self.curr_idx < len(self.components)-1:
	    self.current_line = self.current_line + \
		self.components[self.curr_idx].get_num_of_lines()
	    self.curr_idx = self.curr_idx + 1

    def go_up(self):
	if self.curr_idx > 0:
	    self.curr_idx = self.curr_idx - 1
	    self.current_line = self.current_line - \
		self.components[self.curr_idx].get_num_of_lines()

    def add_component(self, component):
	self.components.insert(self.curr_idx, component)

    def remove_component(self):
	del self.components[self.curr_idx]

    def get_comment_positions(self):
	result = []
	line_nr = 1
	print self.components
	idx = 0
	for component in self.components:
	    idx = idx + 1
	    print idx
	    if component.is_comment():
		result.append(`line_nr` + ".0", `line_nr` + \
		    ".end")
	    line_nr = line_nr + component.get_num_of_lines()
	return result

class TPTPClauseFile (File):

    def __init__(self, lines):
	File.__init__(self, lines)
	self.types =  ( (compon.TPTPClause, "Clause", 
				(("Name", ""),
				("Type", ""),
				("Contents", ""))),
			(compon.Comment, "Comment", 
				(("Contents", ""),)),
			(compon.TPTPInclude, "Include", 
				(("Filename", ""),)),
			(compon.Other, "Other", 
				(("Contents", ""),)))

    def _extract_components(self):
	idx = 0
	components = []

	# Parse all lines
	while idx < len(self.lines):
	    line = self.lines[idx]
	    comment_flag = 0
	    if string.find(line, "%") > -1:
		comment_flag = 1
		components.append(compon.Comment([line]))
		# Remove comment!
		line = line[:string.find(line, "%")]
	    if string.find(line, "input_clause") > -1:
		f_lines = []
		# The following code ignores comments!
		while string.find(line, ".") == -1:
		    f_lines.append(line)
		    idx = idx + 1
		    line = self.lines[idx]
		else:
		    f_lines.append(line)
		    idx = idx + 1
		components.append(compon.TPTPClause(f_lines))
	    elif string.find(line, "include") > -1:
		components.append(compon.TPTPInclude([line]))
		idx = idx + 1
	    elif comment_flag == 0:
		components.append(compon.Other([line]))
		idx = idx + 1
	    else:
		idx = idx + 1
	return components


class SPASSClauseFile (File):
    def __init__(self, lines):
	File.__init__(self, lines)
	
    def _extract_components(self):
	idx = 0
	components = []
	while idx < len(self.lines):
	    line = self.lines[idx]
	    comment_flag = 0
	    if string.find(line, "%") > -1:
		comment_flag = 1
		components.append(compon.Comment([line]))
		# Remove comment!
		line = line[:string.find(line, "%")]
	    if string.find(line, "clause(") > -1 or \
	        string.find(line, "formula(") > -1:
		f_lines = []
		# The following code ignores comments!
		while string.find(line, ".") == -1:
		    f_lines.append(line)
		    idx = idx + 1
		    line = self.lines[idx]
		else:
		    f_lines.append(line)
		    idx = idx + 1
		#components.append(compon.SPASSComp(f_lines))
		components.append(compon.SPASSClause(f_lines))
	    elif comment_flag == 0:
		components.append(compon.Other([line]))
		idx = idx + 1
	    else:
		idx = idx + 1
	return components
   
class OtterFile (File):
    def __init__(self, lines):
	File.__init__(self, lines)
	
    def _extract_components(self):
	idx = 0
	components = []
	while idx < len(self.lines):
	    line = self.lines[idx]
	    comment_flag = 0
	    if string.find(line, "%") > -1:
		print "comment found"
		comment_flag = 1
		components.append(compon.Comment([line]))
		# Remove comment!
		line = line[:string.find(line, "%")]
		idx=idx+1
	    elif string.strip(line) == "":
		print "empty line found!"
		components.append(compon.Other([line]))
		idx = idx + 1
	    else:
		print "otter expression found"
		f_lines = []
		# The following code ignores comments!
		while string.find(line, ".") == -1:
		    f_lines.append(line)
		    idx = idx + 1
		    line = self.lines[idx]
		else:
		    f_lines.append(line)
		    idx = idx + 1
		print "F-Lines:", f_lines
		components.append(compon.OtterExpression(f_lines))
	return components
   
def test():
    f = open("BOO002-1.p")
    lines = f.readlines()
    return TPTPClauseFile(lines)

if __name__ == "__main__":
    test()










