#!/usr/local/bin/python
import sys
import os
import string
import glob
import tkMessageBox
from Tkinter import *
from Tkconstants import *
from FileDialog import *  
from io import *


###########################################################################################
###########################################################################################
##													##
##	FLOTTER - dfg to cnf translation									##
##		classes:											##
##			Flotter										##
##													##
###########################################################################################
###########################################################################################



class flotter_flags:
##########################################################################################
#Presents frame with flags for screen output									#
#		flags:											#
#			CNFOptSkolem									#
#			CNFProofSteps									#
#			CNFStrSkolem									#
#			CNFRenaming									#
#			POptSkolem									#
#			PStrSkolem									#
#			CNFPRenaming									#
#													#
#		methods:										#
#			__init__(self,parent=None) ... initialises flags and window				#
#			check_CNFOptSkolem(self) ... checks flag if print-flag is set				#
#			check_CNFStrSkolem(self) ... checks flag if print-flag is set				#
#			check_CNFRenaming(self) ... checks flag if print-flag is set				#
#			load(self) ... loads flag-configuration						#
#			save(self) ... saves configuration							#
#			quit(self) ... quits the application							#
#			doFlagLib(self) ... makes dictionary of flag-values					#
#			set_Var(self,dictionary) ... sets flag-values according to dictionary			#
#			do_convert(self) ... writes flags to dfg file and calls Flotter				#
#			show(self) ... shows window							#
##########################################################################################
	def __init__(self,parent=None):
		self.frame=Frame(parent.top)
		self._CNFOptSkolem=IntVar()
		self._CNFOptSkolem.set(1)
		self._CNFProofSteps=StringVar()
		self._CNFProofSteps.set("100")
		self._CNFStrSkolem=IntVar()
		self._CNFStrSkolem.set(1)
		self._CNFRenaming=IntVar()
		self._CNFRenaming.set(0)
		self._POptSkolem=IntVar()
		self._POptSkolem.set(0)
		self._PStrSkolem=IntVar()
		self._PStrSkolem.set(0)
		self._CNFPRenaming=IntVar()
		self._CNFPRenaming.set(0)

		label1 = Label(self.frame, text="optimized skolemization:")
		label2 = Label(self.frame, text="strong skolemization:")
		label3 = Label(self.frame, text="number of optimized skolemization proof steps:")
		label4 = Label(self.frame, text="perform renaming:")
		label30 = Label(self.frame, text="Optimized skolemization output:")
		label33 = Label(self.frame, text="Strong skolemization output:")
		label35 = Label(self.frame, text="print renaming:")
		label1.grid(row=1, column=0,sticky="E")
		label2.grid(row=2, column=0,sticky="E")
		label3.grid(row=3, column=0,sticky="E")
		label4.grid(row=4, column=0,sticky="E")
		label30.grid(row=29, column=0,sticky="E")
		label33.grid(row=30, column=0,sticky="E")
		label35.grid(row=34, column=0,sticky="E")

		radio11=Radiobutton(self.frame,text="on",variable=self._CNFOptSkolem,value=1)
		radio12=Radiobutton(self.frame,text="off",variable=self._CNFOptSkolem,value=0)

		radio21=Radiobutton(self.frame,text="on",variable=self._CNFStrSkolem,value=1)
		radio22=Radiobutton(self.frame,text="off",variable=self._CNFStrSkolem,value=0)

		self.CNFProofStepsEntry=Entry(self.frame,textvariable=self._CNFProofSteps,width=6)

		radio41=Radiobutton(self.frame,text="on",variable=self._CNFRenaming,value=1)
		radio42=Radiobutton(self.frame,text="off",variable=self._CNFRenaming,value=0)

		radio301=Radiobutton(self.frame,text="on",variable=self._POptSkolem,value=0, command=self.check_CNFOptSkolem)
		radio302=Radiobutton(self.frame,text="off",variable=self._POptSkolem,value=1)

		radio331=Radiobutton(self.frame,text="on",variable=self._PStrSkolem,value=0,command=self.check_CNFStrSkolem)
		radio332=Radiobutton(self.frame,text="off",variable=self._PStrSkolem,value=1)

		radio351=Radiobutton(self.frame,text="on",variable=self._CNFPRenaming,value=0,command=self.check_CNFRenaming)
		radio352=Radiobutton(self.frame,text="off",variable=self._CNFPRenaming,value=1)

		radio11.grid(row=1,column=1,sticky="W")
		radio12.grid(row=1,column=2,sticky="W")
		radio21.grid(row=2,column=1,sticky="W")
		radio22.grid(row=2,column=2,sticky="W")
		self.CNFProofStepsEntry.grid(row=3,column=1,sticky="W",pady=4)
		radio41.grid(row=4,column=1,sticky="W")
		radio42.grid(row=4,column=2,sticky="W")
		radio301.grid(row=29,column=1,sticky="W")
		radio302.grid(row=29,column=2,sticky="W")
		radio331.grid(row=30,column=1,sticky="W")
		radio332.grid(row=30,column=2,sticky="W")
		radio351.grid(row=34,column=1,sticky="W")
		radio352.grid(row=34,column=2,sticky="W")

	def check_CNFOptSkolem(self):
		if self._CNFOptSkolem.get()==0:
			tkMessageBox.showinfo("deactivated","Optimized Skolemization not activated")

	def check_CNFStrSkolem(self):
		if self._CNFStrSkolem.get()==0:
			tkMessageBox.showinfo("deactivated","Optimized Skolemization not activated")

	def check_CNFRenaming(self):
		if self._CNFRenaming.get()==0:
			tkMessageBox.showinfo("deactivated","Renaming not activated")


