import string
from comment import Comment
from clause import Clause

class Formula:

	def __init__(self, lines):
		self.commentLetter = "%"
		self.comments=[]
		self.clauses=[]

		self.lines = lines
		new_lines = self.ExtractComments(lines)
		self.ExtractClauses(new_lines)

	def __repr__(self):
		result = ""
		for line in self.lines:
			result = result + line
		return result

	def ExtractComments(self, lines):

		new_lines = []
		for idx in range(len(lines)):
			pos = string.find(lines[idx], self.commentLetter)
		        if pos > -1:
				start = (idx, pos)
				end = (idx, len(lines[idx]))

				comment = Comment(lines[idx][pos:], start, end)
				self.comments.append(comment)
				new_lines.append(lines[idx][0:pos])
			else:
				new_lines.append(lines[idx])
		return new_lines

	def _make_tcl_index(self, pair):
		return str(pair[0]+1)+"."+str(pair[1])

	def ExtractClauses(self, lines):
		idx = 0
		while idx < len(lines):
			pos = string.find(lines[idx], "input_clause")
			if pos > -1:
				f_lines = [lines[idx]]
				start = idx, pos
				pos = string.find(lines[idx], ".")
				while idx < len(lines):
					pos = string.find(lines[idx], ".")
					if pos > -1:
						break
					idx = idx + 1
					f_lines.append(lines[idx])
				end = idx, pos+1
				self.clauses.append(Clause(f_lines,start,end))
			idx = idx + 1
					
	def GetCommentPositions(self):
		result = []
		for comment in self.comments:
			result.append(comment.GetPosition())
		return result
				

	def get_clause_pos(self, number):
		return self.clauses[number].GetPosition()

	def get_description(self, number):
		return self.clauses[number].get_description()

	def num_of_clauses(self):
		return len(self.clauses)

	def add_clause(self, position, clause):
		self.clauses.insert(position, 
				    Clause([clause], 
					   self.clauses[position].start, 
					   self.clauses[position].start
					  )
				   )




