#!/usr/local/bin/python
import sys
import os
import string
import tkMessageBox

###########################################################################################
###########################################################################################
##													##
##	IO CLASSES - modules for save and load								##
##			classes:										##
##				NewFileName								##
##				FlagIO									##
##													##
###########################################################################################
###########################################################################################

class NewFileName:
##########################################################################################
#	Computes a new Filename										#
#		methods:										#
#			get(self,directory,name,extension)							#
##########################################################################################
	def get(self,directory,name,extension):
	###################################################################################
	#	Returns a new File Name, when given a directory, a file-name and a file-extension			#
	#		NewFileName=directory\file-nameXXXX.file-extension	XXXX is number		#
	###################################################################################
		directory=os.path.normcase(directory)
		try:
			dirlist=os.listdir(directory)
		except:
			tkMessageBox.showerror("Directory","Directory does not exist - \n" + directory)
			return "ERROR"
		l=len(dirlist)
		next=0
		for i in range (0,l):
			x0=string.splitfields(dirlist[i],".")	#	#x0=[name,extension]
			try:
				if (len(x0)==2 and x0[1]==extension):
					x1=string.splitfields(x0[0],name)	#x1=['',number]
					try:
						j=eval(x1[1])
						if j>=next:
							next=j+1
					except:
						pass
			except:
				pass
		#	format=nameXXXX.extension		#
		for i in [1]:
			if next<9:
				NewFile=name+"000"+str(next)+"."+extension
				break
			if next<99:
				NewFile=name+"00"+str(next)+"."+extension
				break
			if next<999:
				NewFile=name+"0"+str(next)+"."+extension
				break
			NewFile=name+str(next)+"."+extension
		return NewFile

class FlagIO:
##########################################################################################
#	methods for flag load and save									#
#		methods:										#
#			load_SPASS(self,filename,lineNR=0) ... returns dictionary of flag-settings		#
#			save_SPASS(self,filename,dictionary) ... saves flag-settings to file			#
#			FinalFile2_SPASS(self,filename,flags) ... saves flag-settings to SPASS/Flotter-input-file	#
##########################################################################################
	def load_SPASS(self,filename,lineNr=0):
	###################################################################################
	#	returns dictionary of flag-settings read from filename						#
	#		file: 	set_flag(flagname,flagvalue)						#
	#			...									#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	#		if given lineNr filename is checked for NumberOfLines=lineNr				#
	###################################################################################
		f = open(filename)
		lines = f.readlines()
		f.close()
		numOfLines = len(lines)
		print numOfLines
		x={}
		if ((numOfLines==lineNr and lineNr>0) or (lineNr==0)):
			try:
				for i in range(numOfLines):
					x0=string.splitfields(lines[i],",")		#	x0=['set_flag(X' , 'Y).']
					x1=string.splitfields(x0[0],"set_flag(")	# 	x1=['' , 'X']
					x2=string.splitfields(x0[1],").\012")		#	x2=[Y , '']
					x[x1[1]]=x2[0]
				return x
			except:
				tkMessageBox.showerror("File","Error in Flag-File - bad flag-definition found - \n" + filename )
				return "ERROR"
		else:
			tkMessageBox.showerror("File","Error in Flag-File - wrong number of lines in " + filename + "\n (probably not all flags defined)")
			return "ERROR"

	def save_SPASS(self,filename,dictionary):
	###################################################################################
	#	writes dictionary to filename								#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	#		file: 	set_flag(flagname,flagvalue)						#
	#			...									#
	###################################################################################
		f=open(filename,"w")
		for i in dictionary.keys():
			if (i<>"Cancel" and i<>"Error"):
				j=dictionary[i]					
				f.write("set_flag("+i+","+str(dictionary[i])+").\n")		
		f.close

	def FinalFile2_SPASS(self,filename,SPASS_dictionary,Flotter_dictionary):
	###################################################################################
	#	writes dictionary to right place in filename							#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	#		file: 										#
	#			Input File to SPASS or FLOTTER						#
	#				begin_problem							#
	#				.....								#
	#		add:		list_of_settings(SPASS).						#
	#		.....		{*								#
	#		.....		set_flag(Select,2).							#
	#		.....		.....								#
	#		.....		*}								#
	#		add:		end_of_list.							#
	#				end_problem.							#
	###################################################################################
		f=open(filename)
		main_lines = f.readlines()
		f.close
		new=[]
		numOfLines=len(main_lines)
		forget="F"
		i=0
		while i < numOfLines:
			if forget=="F":
				los=string.find(main_lines[i],"list_of_settings(SPASS).")
				ep=string.find(main_lines[i],"end_problem.")
				if los<>-1:
					l=len(main_lines[i])
					x0=main_lines[i][0:los]
					x1=main_lines[i][los+24:l]
					x0=string.join(string.split(x0))
					if x0<>"":
						new.append(x0)
					x1=string.join(string.split(x1))
					if x1<>"":
						j=numOfLines-1
						numOfLines=numOfLines+1
						main_lines.append(main_lines[j])
						while j>i+1:
							main_lines[j]=main_lines[j-1]
							j=j-1
						main_lines[j]=x1
					forget="T"
				elif ep<>-1:
					x0=main_lines[i][0:ep]
					x0=string.join(string.split(x0))
					if x0<>"":
						new.append(x0)
					new.append("\nlist_of_settings(SPASS).\n{*\n")
					for j in SPASS_dictionary.keys():
						if (j<>"Error" and j<>"Cancel"):
							new.append("set_flag(" + str(j) + "," +  str(SPASS_dictionary[j]) + ").\n")
					for j in Flotter_dictionary.keys():
						if (j<>"Error" and j<>"Cancel"):
							new.append("set_flag(" + str(j) + "," +  str(Flotter_dictionary[j]) + ").\n")
					new.append("*}\nend_of_list.\n")
					new.append("end_problem.")
				else: 
					if string.join(string.split(main_lines[i]))<>"":
						new.append(main_lines[i])
			else:
				eol=string.find(main_lines[i],"end_of_list.")
				if eol<>-1:
					l=len(main_lines[i])
					x1=main_lines[i][eol+12:l]
					x1=string.join(string.split(x1))
					if x1<>"":
						j=numOfLines-1
						numOfLines=numOfLines+1
						main_lines.append(main_lines[j])
						while j>i+1:
							main_lines[j]=main_lines[j-1]
							j=j-1
						main_lines[j]=x1
					forget="F"
			i=i+1
		f=open(filename,"w")
		new_nr=len(new)		
		for i in range(new_nr):
			f.write(new[i])
		f.close


	def load_Otter(self,filename,lineNr=0):
	###################################################################################
	#	returns dictionary of flag-settings read from filename						#
	#		file: 	set(flagname)								#
	#			clear(flagname)								#
	#			...									#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	#		if given lineNr filename is checked for NumberOfLines=lineNr				#
	###################################################################################
		f = open(filename)
		lines = f.readlines()
		f.close()
		numOfLines = len(lines)
		x={}
		if ((numOfLines==lineNr and lineNr>0) or (lineNr==0)):
			for i in range(numOfLines):
				if string.find(lines[i],"set")==-1:
					if string.find(lines[i],"clear")==-1:
						tkMessageBox.showerror("File","Error in Flag-File - bad flag-definition found - \n" + filename )
					#	return "ERROR"
					else:						#lines[i]=clear(X).
						x0=string.splitfields(lines[i],"clear(")		#x0=["","X)."]
						x1=string.splitfields(x0[1],").")		#x1=["X",""]
						x[x1[0]]="0"
				else:							#lines[i]=set(X).
					x0=string.splitfields(lines[i],"set(")			#x0=["","X)."]
					x1=string.splitfields(x0[1],").")			#x1=["X",""]
					x[x1[0]]="1"
			return x
		else:
			tkMessageBox.showerror("File","Error in Flag-File - wrong number of lines in " + filename + "\n (probably not all flags defined)")
			return "ERROR"


	def save_Otter(self,filename,dictionary):
	###################################################################################
	#	writes dictionary to filename								#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	#		file: 	set(flagname)								#
	#				or								#
	#			clear(flagname)								#
	#			...									#
	###################################################################################
		f=open(filename,"w")
		for i in dictionary.keys():
			if (i<>"Cancel" and i<>"Error"):
				j=dictionary[i]
				if j==0:					
					f.write("clear("+i+").\n")		
				if j==1:
					f.write("set("+i+").\n")
#				if i=="p_dict":
#					for k in j.keys():
#						f.write(k+"="+str(j[k])+".\n")	
		f.close

	def FinalFile2_Otter(self,filename,dictionary):
		f=open(filename)
		main_lines = f.readlines()		
		f.close
		l=len(main_lines)
		f=open(filename,"w")
		for i in dictionary.keys():
			if (i<>"Cancel" and i<>"Error"):
				j=dictionary[i]
				if j==0:					
					f.write("clear("+i+").\n")		
				if j==1:
					f.write("set("+i+").\n")
		for i in range(l):
			f.write(main_lines[i])
		f.close

	def save_TPTP(self,filename,dictionary):
	###################################################################################
	#	writes dictionary to filename								#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	#		file: 	flagname flagvalue							#
	#			...									#
	###################################################################################
		f=open(filename,"w")
		for i in dictionary.keys():
			if (i<>"Cancel"):
				f.write(i + " " + str(dictionary[i]) + "\n")		
		f.close

	def load_TPTP(self,filename,lineNr=0):
	###################################################################################
	#	returns dictionary of flag-settings read from filename						#
	#		file: 	flagname flagvalue							#
	#			...									#
	#		dictionary:									#
	#			{flagname:flagvalue,...}							#
	###################################################################################
		f = open(filename)
		lines = f.readlines()
		f.close()
		numOfLines = len(lines)
		x={}
		if ((numOfLines==lineNr and lineNr>0) or (lineNr==0)):
			for i in range(numOfLines):
				try:
					x0=string.split(lines[i])		#	x=[flagname,flagvalue]
					x[x0[0]]=x0[1]
				except:
						tkMessageBox.showerror("File","Error in Flag-File - bad flag-definition found - \n" + filename )
						return "ERROR"
			return x
		else:
			tkMessageBox.showerror("File","Error in Flag-File - wrong number of lines in " + filename + "\n (probably not all flags defined)")
			return "ERROR"



