#!/usr/local/bin/python
import sys
import os
import string
import glob
import guimaker
from Tkinter import *
from ScrolledText import ScrolledText
from FileDialog import LoadFileDialog, SaveFileDialog
from ClauseEditor import ClauseEditor # Sollte spter nicht mehr ntig sein!
from FormulaEditor import FormulaEditor
from Formula import Formula
from spass import SPASS_Flags
import tkMessageBox
from SPASS_Flags import SPASS_Flags
from Clause_Evaluation import Clause_Evaluation
from Flotter_Flags import *
from Otter_Flags import *
from Preferences import *
import output
from io import *
from TPTP2X_Flags import *
from ShowOutput import *

class MB(guimaker.GuiMaker):
	"""Represents the main window."""

	def start(self, parent=None):
		"""Initialization of the dialog"""

		self.parent = parent		# The parent (tk in our case)
		self.file = StringVar()		# The name of the current file
		self.file.set("")
		self._class = StringVar()	# The class of the current file
		self._class.set("")
		self.sat = StringVar()
		self.sat.set("")		# Is current file satisfiable?
		self.num=1			# Number of formulas inserted with
						# "Add Formula"
		self.numOfLines = 0		# number of lines in Text Area
		self.dir = "/home/albert/tilt"
						# Starting directory for File Open
						# Dialog

		self.pack()
######
		self.spass_flag_object="F"
		self.otter_flag_object="F"
#######		
		# Initialize the menu bar. This list is evaluated by GuiMaker.
		self.menuBar = [
			("File", 0,
				[("New", 0,
					[("TPTP",0,self.clear_editor),
					("CNF",0,self.clear_editor),
					("DFG",0,self.clear_editor),
					("Otter",0,self.clear_editor)]),
				 ("Open", 0, self.open_file),
			 	 ("Save", 0, self.save_file),
				 ("Exit", 0, self.quit_app)]),
			("Edit", 0,
				[("Add Formula", 0, self.add_clause),
				 ("Edit Formula", 0, self.edit_clause),
				 ("Remove Formula", 0, self.remove_clause),
				("Add Comment", 0, self.add_comment),
				 ("Edit Comment", 0, self.edit_comment),
				 ("Remove Comment", 0, self.remove_comment)]),
			("Tools", 0,
				[("Clause Evaluation", 0, self.clause_eval),
				("Convert", 0,
					[("TPTP to", 0,
						[("Otter", 0, self.tptp2otter),    
						 ("DFG", 0, self.tptp2dfg)]),
					 ("DFG to", 0,
						[("Otter", 0, self.do_nothing),    
						 ("TPTP", 0, self.do_nothing),
						 ("CNF", 0, self.dfg2cnf)]),
					 ("Otter to", 0,
						[("TPTP", 0, self.do_nothing),    
						 ("DFG", 0, self.do_nothing)]),
					 ("CNF to", 0,
						[("DFG", 0, self.do_nothing)])])]),
			("Mode", 0,
				[("Auto",0,self.do_nothing),
				  ("Select Strategy",0,
					[("Experimental",0,self.do_stdrd_SPASS),
					  ("Standard",0,self.do_stdrd_Otter)]),
				("Interactive",0,self.do_nothing)
				#("Classify TPTP-File", 0, self.classify),
				# ("Check satisfiability", 6, self.do_nothing),
				 #("Build model", 0, self.do_nothing)
				]),
			("Configuration", 3,
				[("Spass", 0, self.show_SPASS_Flags),
				 ("Otter", 0, self.show_Otter_Flags)]),
			("Preferences", 0,
				[("Directory", 0, self.set_directories)])]
####
		self.SPASS_default=SPASS_Flags(self,"","").show("GET")
		self.Flotter_default=Flotter(self,"").show("GET")
####
	def makeWidgets(self):
		"""Creates the ScrolledText-Field, the button and the
		data-area (filename, class, satisfiability). The last
		part is delegated to self.fill_data_area()"""

		self.text_area = ScrolledText(self, width=70, height=20)
		self.text_area.pack(expand=1, fill=BOTH, padx=2, pady=2)
		self.text_area.focus_set()

		# Die Text-Area wird vom FormulaEditor verwaltet
		self.formula_editor = FormulaEditor(self.text_area)

		self.fill_data_area()
		self.data_area.pack(side=LEFT, expand=1, fill=X)

	def fill_data_area(self):
		"""creates the data-area (filename, class, satisfiability)"""

		self.data_area = Frame(self, bd=2, relief = SUNKEN)

		self.label_filename = Label(self.data_area, 
					textvariable=self.file)
		self.label_filename.pack(side=LEFT)
#		self.label_class = Label(self.data_area, 
#					textvariable=self._class)
#		self.label_class.pack(side=LEFT)
#		self.label_sat = Label(self.data_area, 
#					textvariable = self.sat)
#		self.label_sat.pack(side=LEFT)

####
	def getDirs(self):
		if os.path.exists("AutoMod.pref"):
			self.dirs=getPreferences().getDirectories()
			if self.dirs["Error"]=="F":
				if (os.path.exists(self.dirs["mainDir"]) and os.path.exists(self.dirs["spassDir"]) and os.path.exists(self.dirs["flotterDir"]) and os.path.exists(self.dirs["otterDir"]) and os.path.exists(self.dirs["modelDir"]) and os.path.exists(self.dirs["tptpDir"])):
					self.setDirs()
				else:
					self.dirs=SetDirectories(self).show()
					self.setDirs()
			else:
				self.dirs=SetDirectories(self).show()
				self.setDirs()
		else:
			self.dirs=SetDirectories(self).show()
			self.setDirs()

	def setDirs(self):
		self.MainDir=self.dirs["mainDir"]
		self.SpassDir=self.dirs["spassDir"]
		self.FlotterDir=self.dirs["flotterDir"]
		self.OtterDir=self.dirs["otterDir"]
		self.TptpDir=self.dirs["tptpDir"]
		self.ModelDir=self.dirs["modelDir"]
#####

	def show_testfile(self):
		"""Presents the contents of self.file in the Text Area"""
        	if self.file.get() == "":
			pass
	       	else:
			f = open(self.file.get())
			lines = f.readlines()
			f.close()
			self.formula = Formula(lines)
			self.formula_editor.show_formula(self.formula)

	def do_nothing(self) : 
		"""Used for all functions which are not yet implemented"""
		pass

	def clear_editor(self):
		self.getDirs()
		self.formula_editor.clear_contents()

	def open_file(self):
		"""Opens a file using the file dialog. Clears the
		contents of the Text Area (using self.clear_editor())
		and refills it with the contents of the file (using
		self.show_testfile())."""

		self.getDirs()
		fd = LoadFileDialog(self)
		filename = fd.go(".", "*.*", "", 1)
		if filename != None:
			self.file.set(filename)
			self._class.set("")
			self.clear_editor()
			self.show_testfile()

	def save_file(self):
		fd=SaveFileDialog(self)
		filename = fd.go(".","*.*", "", 1)
		if filename<>None:
			self.do_save(filename)


	def do_save(self,fname):
		f=open(fname,"w")
		j0=string.splitfields(self.text_area.index("end"),".")
		j=eval(j0[0])
		for i in range(1,j):
			f.write(self.text_area.get(str(i)+".0",
			str(self.text_area.index(str(i)+".0 lineend")))+"\n")
		f.write("\n")
		f.close

	def classify(self):
		"""Calls the classifier and checks whether there exists
		a file *.pvd.p or *.pvdeq.p. Fills the "Class"-Field
		accordingly"""

		filename=self.file.get()
		command = \
		  'echo "[classify]. classify(\'%s\', _, _). halt." | pl' \
			  % (filename)
		os.system(command)
		components = string.splitfields(filename, ".")
		pvd = components[:-1]+["pvd"]+components[-1:]
		pvdeq = components[:-1]+["pvdeq"]+components[-1:]
		print pvd
		print pvdeq
		if glob.glob(string.joinfields(pvd, ".")):
			self._class.set("PVD")
		elif glob.glob(string.joinfields(pvdeq, ".")):
			self._class.set("PVD_g^=")
		else:
			self._class.set("unknown")
	def tst(self):
		self.tmp=ShowOutput(self)
		self.tmp.show()
		theOut = Output(self.tmp.op_area)
		sys.stdout = theOut
		sys.stderr = theOut
		os.system("dir")
####
	def clause_eval(self):
		self.getDirs()
		Clause_Evaluation(self,self.ModelDir).show()			

	def dfg2cnf(self):
		x=Flotter(self,self.FlotterDir).show("SHOW")
		print x
		if x["Cancel"]=="F":
			self.do_save("SPASS_Out.cnf")
			FlagIO().FinalFile2_SPASS("SPASS_Out.cnf",{},x)
			self.tmp=ShowOutput(self, "DFG 2 CNF Output")
			self.tmp.show()
			p = os.popen("spass SPASS_Out.cnf")
			lines = p.readlines()
			i=0
			for line in lines:
				self.tmp.op_area.insert(`i`+".0", line)
				i=i+1

	def tptp2otter(self):
		x=TPTP2X(self,"Otter",self.TptpDir).show()
		self.tptp2X("Otter",x)

	def tptp2dfg(self):
		x=TPTP2X(self,"Dfg",self.TptpDir).show()
		self.tptp2X("Dfg",x)

	def tptp2X(self,name,tptp):
		if tptp<>"CANCEL":
			self.do_save("TPTP2X.p")
			conv=string.lower(name)
			tptp=tptp + " -f" + conv + " -d'-' TPTP2X.p"
			print tptp
			t="TPTP 2 " + name + "Output"
			self.tmp=ShowOutput(self, t)
			self.tmp.show()
			p = os.popen(tptp)
			lines = p.readlines()
			i=0
			for line in lines:
				self.tmp.op_area.insert(`i`+".0", line)
				i=i+1

	def set_directories(self): 
		SetDirectories(self).show()

	def show_SPASS_Flags(self):
		if self.spass_flag_object=="F":
			self.spass_flag_object="T"
			x=SPASS_Flags(self,self.MainDir,self.SpassDir).show("SHOW")
			if os.path.exists(self.MainDir):
				if ((x["Cancel"]=="F" and x["Error"]=="F" and len(x.keys())>3) or (len(x.keys())==3 and x["Auto"]=="1")):
					FlagIO().save_SPASS(self.MainDir+"\SPASS_Flags.ext",x)
			else:
				tkMessageBox.showerror("Directory","Directory does not exist - \n" + self.MainDir)
			self.spass_flag_object="F"
		else:
			tkMessageBox.showinfo("Flag-Setting","Window for SPASS-Flag-Setting already open")
			pass

	def show_Otter_Flags(self):
		if self.otter_flag_object=="F":
			self.otter_flag_object="T"
			x=Otter_Flags(self,self.MainDir,self.OtterDir).show()
			self.otter_flag_object="F"
		else:
			tkMessageBox.showinfo("Flag-Setting","Window for Otter-Flag-Setting already open")


	def do_stdrd_SPASS(self):
		tkMessageBox.showinfo("Flag-Setting","Flag-settings in File ignored - take own flag-settings")
		if self.file.get()=="":
			f="SPASS_Out.dfg"
		else:
			x=string.splitfields(self.file.get(),".")
			l=len(x)
			if x[l-1]=="cnf":
				f="SPASS_Out.cnf"
			elif x[l-1]=="dfg":
				f="SPASS_Out.dfg"
		self.do_save(f)
		FlagIO().FinalFile2_SPASS(f,self.SPASS_default,self.Flotter_default)
		self.tmp=ShowOutput(self, "SPASS Output")
		self.tmp.show()
		p = os.popen("spass " + f)
		lines = p.readlines()
		i=0
		for line in lines:
			self.tmp.op_area.insert(`i`+".0", line)
			i=i+1

	def do_stdrd_Otter(self):
		self.do_save("Otter_Out.in")
		self.tmp=ShowOutput(self, "Otter Output")
		self.tmp.show()
		p = os.popen("otter < Otter_Out.in")
		lines = p.readlines()
		i=0
		for line in lines:
			self.tmp.op_area.insert(`i`+".0", line)
			i=i+1
#####
		
	def quit_app(self):
		"""Quits the application and python"""
		raise SystemExit			

	def add_clause(self):
		self.formula_editor.add_clause()

	def edit_clause(self):
		pass

	def remove_clause(self):
		pass

	def add_comment(self):
		pass

	def edit_comment(self):
		pass

	def remove_comment(self):
		pass

tk = Tk()
MB(tk).mainloop()
