#!/usr/local/bin/python
import sys
import os
import string
import glob
import tkmsgbox
from Tkinter import *
from Tkconstants import *
from FileDialog import LoadFileDialog
from FileDialog import SaveFileDialog
from ottgrp import *
from io import *


###########################################################################################
###########################################################################################
##													##
##	WINDOW TO SET Otter FLAGS									##
##			classes:										##
##				Otter_Flags								##
##													##
###########################################################################################
###########################################################################################

class Otter_Flags:
##########################################################################################
#	presents main window to set SPASS flags; handles the whole SPASS-Flag-Configuration			#
#		methods:										#
#			__init__(self,parent=None)							#	
#			chc(self) ... changes button-colour and shows flags					#
#			opt(self) ... changes button-colour and shows flags					#
#			pt(self) ... changes button-colour and shows flags					#
#			ifr(self) ... changes button-colour and shows flags					#
#			redr(self) ... changes button-colour and shows flags					#
#			wgt(self) ... changes button-colour and shows flags					#
#			skl(self) ... changes button-colour and shows flags					#
#			cl(self) ... changes button-colour and shows flags					#
#			syst(self) ... changes button-colour and shows flags					#
#			deltn(self) ... changes button-colour and shows flags					#
#			autm(self) ... changes button-colour and shows flags					#
#			mk_b(self) ... changes button-color to black						#
#			 hide_all_radios(self) ... sets all flag-groups invisible					#
#			quit(self) ... quits the flag-application if settings are ok					#
#			cancel(self) ... quits the flag-application; sets "Cancel" true				#
#			save_set(self) ... saves the flag-configuration to a file					#
#			load(self) ... loads a flag-configuration from a file					#
#			set_Var(self,dictionary) ... sets the flag-variables according to the dictionary-entrys	#
#			doFlagLib(self) ... returns dictionary of flag-values					#
#			show(self) ... shows window, when destroyed returns flag-dictionary			#
#		uses classes:										#
#			choose_calc(self)									#
#			outpt										#
#			prnt										#
#			inference_rule									#
#			reduction									#
#			weight										#
#			skolemisation									#
#			calculus										#
#			system										#
#			deletion										#
#		constants:										#
#			self.directory ... set in int; main directory of program; to make name of flag-directory	#
#					flag_directory=self.directory + \flags				#
##########################################################################################

	###################################################################################
	#	__init__											#
	###################################################################################
	def __init__(self,parent=None,directory,defaults,last):
		###################################
		#	menu and buttons		#
		###################################
		#	Frames for menu and buttons	#
		self.top = Toplevel()
		self.directory=directory
		self.defaults=defaults
		self.last=last
		self.top.title("Otter-Flags")
		self.menu_frame=Frame(self.top,relief=RAISED,bd=2)
		self.menu_frame.pack(side=TOP,fill=X)
		self.frame=Frame(self.top)
		self.frame.pack(side=BOTTOM,fill=X)
		self.frame11 = Frame(self.frame)
		self.frame11.grid(row=0,column=0,sticky="nw",padx=10,pady=10)
		self.frame1 = Frame(self.frame)
		self.frame1.grid(row=0,column=1,sticky="ne",pady=10)
		self.frame2 = Frame(self.frame)
		self.frame2.grid(row=0,column=2,sticky="w",padx=10,pady=10)
		self.frame31 = Frame(self.frame)
		self.frame31.grid(row=1,column=0,sticky="nw",padx=10,pady=10)
		self.frame3 = Frame(self.frame)
		self.frame3.grid(row=1,column=1,sticky="ne",pady=10)
		self.frame4 = Frame(self.frame)
		self.frame4.grid(row=1,column=2,sticky="w",padx=10,pady=10)
		label1 = Label(self.frame11, text="FLAGS:")
		label1.grid(row=0,column=0,sticky="W")
#		label2 = Label(self.frame31, text="PARAMETERS:")
#		label2.grid(row=0,column=0,sticky="W")
		#	buttons				#
		self.ml_button=Button(self.frame1,text="Main Loop",relief=FLAT,command=self.mlb)
		self.ml_button.grid(row=0,column=1,sticky="E")
		self.ir_button=Button(self.frame1,text="Inference Rules",relief=FLAT,command=self.irb)
		self.ir_button.grid(row=1,column=1,sticky="E")
		self.pm_button=Button(self.frame1,text="Paramodulation",relief=FLAT,command=self.pmb)
		self.pm_button.grid(row=2,column=1,sticky="E")
		self.hgc_button=Button(self.frame1,text="Handling generated clauses",relief=FLAT,command=self.hgcb)
		self.hgc_button.grid(row=3,column=1,sticky="E")
		self.do_button=Button(self.frame1,text="Demodulation and ordering",relief=FLAT,command=self.dob)
		self.do_button.grid(row=4,column=1,sticky="E")
		self.ip_button=Button(self.frame1,text="Input",relief=FLAT,command=self.ipb)
		self.ip_button.grid(row=5,column=1,sticky="E")
		self.op_button=Button(self.frame1,text="Output",relief=FLAT,command=self.opb)
		self.op_button.grid(row=6,column=1,sticky="E")
		self.ind_button=Button(self.frame1,text="Indexing",relief=FLAT,command=self.indb)
		self.ind_button.grid(row=7,column=1,sticky="E")
		self.misc_button=Button(self.frame1,text="Miscellaneous",relief=FLAT,command=self.miscb)
		self.misc_button.grid(row=8,column=1,sticky="E")
#		self.p_mon_button=Button(self.frame3,text="Monitoring Progress",relief=FLAT,command=self.pmonb)
#		self.p_mon_button.grid(row=0,column=1,sticky="E")
#		self.p_src_button=Button(self.frame3,text="Limit Search",relief=FLAT,command=self.psrc)
#		self.p_src_button.grid(row=1,column=1,sticky="E")
#		self.p_genc_button=Button(self.frame3,text="Limit Properties\nof Generated Clauses",justify=RIGHT,relief=FLAT,command=self.pgenc)
#		self.p_genc_button.grid(row=2,column=1,sticky="E")
#		self.p_ind_button=Button(self.frame3,text="Indexing",justify=RIGHT,relief=FLAT,command=self.pind)
#		self.p_ind_button.grid(row=3,column=1,sticky="E")
#		self.p_misc_button=Button(self.frame3,text="Miscellaneous",justify=RIGHT,relief=FLAT,command=self.pmisc)
#		self.p_misc_button.grid(row=4,column=1,sticky="E")
		#	menu				#
		setButton=Menubutton(self.menu_frame,text="Setting")
		setButton.pack(side=LEFT)
		self.setMenu=Menu(setButton)
		self.setMenu.add_command(label="Save",command=self.save_set)
		self.setMenu.add_command(label="Load",command=self.load)
		self.setMenu.add_separator()
		self.setMenu.add_command(label="Load Standard",command=self.load_standard)
		self.setMenu.add_separator()
		self.setMenu.add_command(label="Cancel",command=self.cancel)
		self.setMenu.add_command(label="Accept",command=self.quit)
		setButton["menu"]=self.setMenu
		###################################
		#	initialises classes for flag-groups	#
		#	initialises dictionary		#
		#	initialises directory		#
		###################################
		self.ml=main_loop(self,self.frame2)
		self.pm=paramodulation(self,self.frame2)
		self.ir=inference_rules(self,self.frame2)
		self.hgc=handling_generated_clauses(self,self.frame2)
		self.do=demodulation_ordering(self,self.frame2)
		self.ip=input(self,self.frame2)
		self.op=output(self,self.frame2)
		self.ind=indexing(self,self.frame2)
		self.misc=miscellaneous(self,self.frame2)
#		self.p_mon=p_monitoring_progress(self,self.frame4)
#		self.p_src=p_search_limits(self,self.frame4)
#		self.p_genc=p_gen_clause_limits(self,self.frame4)
#		self.p_ind=p_indexing(self,self.frame4)
#		self.p_misc=p_miscellaneous(self,self.frame4)
		self.dict={}
		self.dict["Cancel"]=""
		self.dict["Error"]="F"

	###################################################################################
	#	button-functions										#
	###################################################################################

	def mlb(self):
		self.mk_b()
		self.ml_button.config(foreground="red")
		self.hide_all_radios()
		self.ml.frame.pack(padx=10)

	def irb(self):
		self.mk_b()
		self.ir_button.config(foreground="red")
		self.hide_all_radios()
		self.ir.frame.pack(padx=10)

	def pmb(self):
		self.mk_b()
		self.pm_button.config(foreground="red")
		self.hide_all_radios()
		self.pm.frame.pack(padx=10)

	def hgcb(self):
		self.mk_b()
		self.hgc_button.config(foreground="red")
		self.hide_all_radios()
		self.hgc.frame.pack(padx=10)

	def dob(self):
		self.mk_b()
		self.do_button.config(foreground="red")
		self.hide_all_radios()
		self.do.frame.pack(padx=10)
		self.do.check_lex_order_vars()

	def ipb(self):
		self.mk_b()
		self.ip_button.config(foreground="red")
		self.hide_all_radios()
		self.ip.frame.pack(padx=10)
		self.ip.check_process_input()

	def opb(self):
		self.mk_b()
		self.op_button.config(foreground="red")
		self.hide_all_radios()
		self.op.frame.pack(padx=10)
		self.op.check_dynamic_demod()
		self.op.check_back_demod()
		self.op.check_back_sub()
	
	def indb(self):
		self.mk_b()
		self.ind_button.config(foreground="red")
		self.hide_all_radios()
		self.ind.frame.pack(padx=10)
		self.ind.check_back_demod()

	def miscb(self):
		self.mk_b()
		self.misc_button.config(foreground="red")
		self.hide_all_radios()
		self.misc.frame.pack(padx=10)

	def pmonb(self):
		self.p_mk_b()
		self.p_mon_button.config(foreground="red")
		self.hide_all_paras()
		self.p_mon.frame.pack(padx=10)

	def psrc(self):
		self.p_mk_b()
		self.p_src_button.config(foreground="red")
		self.hide_all_paras()
		self.p_src.frame.pack(padx=10)

	def pgenc(self):
		self.p_mk_b()
		self.p_genc_button.config(foreground="red")
		self.hide_all_paras()
		self.p_genc.frame.pack(padx=10)

	def pind(self):
		self.p_mk_b()
		self.p_ind_button.config(foreground="red")
		self.hide_all_paras()
		self.p_ind.frame.pack(padx=10)

	def pmisc(self):
		self.p_mk_b()
		self.p_misc_button.config(foreground="red")
		self.hide_all_paras()
		self.p_misc.frame.pack(padx=10)

	def mk_b(self):
		self.ml_button.config(foreground="black")
		self.ir_button.config(foreground="black")
		self.pm_button.config(foreground="black")
		self.hgc_button.config(foreground="black")
		self.do_button.config(foreground="black")
		self.ip_button.config(foreground="black")
		self.op_button.config(foreground="black")
		self.ind_button.config(foreground="black")
		self.misc_button.config(foreground="black")

	def p_mk_b(self):
		self.p_mon_button.config(foreground="black")
		self.p_src_button.config(foreground="black")
		self.p_genc_button.config(foreground="black")
		self.p_ind_button.config(foreground="black")
		self.p_misc_button.config(foreground="black")

	def  hide_all_radios(self):
		self.ml.frame.forget()
		self.ir.frame.forget()
		self.pm.frame.forget()
		self.hgc.frame.forget()
		self.do.frame.forget()
		self.ip.frame.forget()
		self.op.frame.forget()
		self.ind.frame.forget()
		self.misc.frame.forget()

	def hide_all_paras(self):
		self.p_mon.frame.forget()
		self.p_src.frame.forget()
		self.p_genc.frame.forget()
		self.p_ind.frame.forget()
		self.p_misc.frame.forget()


	###################################################################################
	#	menu-functions										#
	###################################################################################

	def quit(self):
		self.doFlagLib()
		if self.dict["Error"]=="F":
			self.dict["Cancel"]="F"
			self.top.destroy()
		self.dict["Error"]="F"

	def cancel(self):
		self.dict["Cancel"]="T"
		self.top.destroy()

	def save_set(self):
		n=NewFileName().get(self.directory,"otter_flag","flg")
		if n<>"ERROR":
			fd=SaveFileDialog(self.top)
			filename = fd.go(self.directory,"*.flg", n)
			if filename<>None:
				self.doFlagLib()
				if self.dict["Error"]=="F":
					FlagIO().save_Otter(filename,self.dict)
				self.dict["Error"]="F"

	def load_standard(self):
		self.set_Var(self.defaults)

	def load(self):
		if os.path.exists(self.directory):
			fd=LoadFileDialog(self.top)
			filename = fd.go(self.directory,"*.flg")
			if filename<>None:
				x=FlagIO().load_Otter(filename,70)
				self.set_Var(x)
		else:
			tkMessageBox.showerror("Directory","Directory does not exist - \n" + self.directory)

	###################################################################################
	#	convert to integer										#
	###################################################################################

	def make_Var(self,x):
		try:
			x0={}
			for i in x.values():
				x0[i]=eval(x[i])	
			return x0
		except:
			return x



	###################################################################################
	#	dictionary to flag-settings									#
	###################################################################################

	def set_Var(self,x):
		x=self.make_Var(x)
		try:
			self.ml.sos_queue.set(x["sos_queue"])
			self.ml.sos_stack.set(x["sos_stack"])
			self.ml.input_sos_first.set(x["input_sos_first"])
			self.ml.interactive_given.set(x["interactive_given"])
			self.ir.binary_res.set(x["binary_res"])
			self.ir.hyper_res.set(x["hyper_res"])
			self.ir.neg_hyper_res.set(x["neg_hyper_res"])
			self.ir.ur_res.set(x["ur_res"])
			self.ir.para_into.set(x["para_into"])
			self.ir.para_from.set(x["para_from"])
			self.ir.demod_inf.set(x["demod_inf"])
			self.pm.para_from_left.set(x["para_from_left"])
			self.pm.para_from_right.set(x["para_from_right"])
			self.pm.para_into_left.set(x["para_into_left"])
			self.pm.para_into_right.set(x["para_into_right"])
			self.pm.para_from_vars.set(x["para_from_vars"])
			self.pm.para_into_vars.set(x["para_into_vars"])
			self.pm.para_from_units_only.set(x["para_from_units_only"])
			self.pm.para_into_units_only.set(x["para_into_units_only"])
			self.pm.para_skip_skolem.set(x["para_skip_skolem"])
			self.pm.para_ones_rule.set(x["para_ones_rule"])
			self.pm.para_all.set(x["para_all"])
			self.hgc.detailed_history.set(x["detailed_history"])
			self.hgc.order_history.set(x["order_history"])
			self.hgc.unit_deletion.set(x["unit_deletion"])
			self.hgc.delete_identical_nested_skolem.set(x["delete_identical_nested_skolem"])
			self.hgc.sort_literals.set(x["sort_literals"])
			self.hgc.for_sub.set(x["for_sub"])
			self.hgc.back_sub.set(x["back_sub"])
			self.hgc.factor.set(x["factor"])
			self.do.demod_history.set(x["demod_history"])
			self.do.order_eq.set(x["order_eq"])
			self.do.eq_units_both_ways.set(x["eq_units_both_ways"])
			self.do.demod_linear.set(x["demod_linear"])
			self.do.demod_out_in.set(x["demod_out_in"])
			self.do.dynamic_demod.set(x["dynamic_demod"])
			self.do.dynamic_demod_all.set(x["dynamic_demod_all"])
			self.do.dynamic_demod_lex_dep.set(x["dynamic_demod_lex_dep"])
			self.do.back_demod.set(x["back_demod"])
			self.do.knuth_bendix.set(x["knuth_bendix"])
			self.do.lrpo.set(x["lrpo"])
			self.do.lex_order_vars.set(x["lex_order_vars"])
			self.do.symbol_elim.set(x["symbol_elim"])
			self.ip.prolog_style_variables.set(x["prolog_style_variables"])
			self.ip.simplify_fol.set(x["simplify_fol"])
			self.ip.process_input.set(x["process_input"])
			self.ip.check_arity.set(x["check_arity"])
			self.op.very_verbose.set(x["very_verbose"])
			self.op.print_kept.set(x["print_kept"])
			self.op.print_proofs.set(x["print_proofs"])
			self.op.print_new_demod.set(x["print_new_demod"])
			self.op.print_back_demod.set(x["print_back_demod"])
			self.op.print_back_sub.set(x["print_back_sub"])
			self.op.display_terms.set(x["display_terms"])
			self.op.pretty_print.set(x["pretty_print"])
			self.op.bird_print.set(x["bird_print"])
			self.op.echo_included_files.set(x["echo_included_files"])
			self.op.print_given.set(x["print_given"])
			self.op.print_lists_at_end.set(x["print_lists_at_end"])
			self.ind.index_for_back_demod.set(x["index_for_back_demod"])
			self.ind.for_sub_fpa.set(x["for_sub_fpa"])
			self.ind.no_fapl.set(x["no_fapl"])
			self.ind.no_fanl.set(x["no_fanl"])
			self.misc.control_memory.set(x["control_memory"])
			self.misc.order_hyper.set(x["order_hyper"])
			self.misc.propositional.set(x["propositional"])
			self.misc.really_delete_clauses.set(x["really_delete_clauses"])
			self.misc.atom_wt_max_args.set(x["atom_wt_max_args"])
			self.misc.term_wt_max_args.set(x["term_wt_max_args"])
			self.misc.free_all_mem.set(x["free_all_mem"])
#			self.p_mon.report.set(x["report"])
#			self.p_src.max_seconds.set(x["max_seconds"])
#			self.p_src.max_gen.set(x["max_gen"])
#			self.p_src.max_kept.set(x["max_kept"])
#			self.p_src.max_given.set(x["max_given"])
#			self.p_src.max_mem.set(x["max_mem"])
#			self.p_genc.max_literals.set(x["max_literals"])
#			self.p_genc.max_weight.set(x["max_weight"])
#			self.p_genc.max_distinct_vars.set(x["max_distinct_vars"])
#			self.p_ind.fpa_literals.set(x["fpa_literals"])
#			self.p_ind.fpa_terms.set(x["fpa_terms"])
#			self.p_misc.pick_given_ratio.set(x["pick_given_ratio"])
#			self.p_misc.interrupt_given.set(x["interrupt_given"])
#			self.p_misc.demod_limit.set(x["demod_limit"])
#			self.p_misc.max_proofs.set(x["max_proofs"])
			return "OK"
		except:
			return "ERROR"



	###################################################################################
	#	flag-settings to dictionary 									#
	###################################################################################

	def doFlagLib(self):
		for i in [1]:
			self.dict["sos_queue"]=self.ml.sos_queue.get()
			self.dict["sos_stack"]=self.ml.sos_stack.get()
			self.dict["input_sos_first"]=self.ml.input_sos_first.get()
			self.dict["interactive_given"]=self.ml.interactive_given.get()
			self.dict["binary_res"]=self.ir.binary_res.get()
			self.dict["hyper_res"]=self.ir.hyper_res.get()
			self.dict["neg_hyper_res"]=self.ir.neg_hyper_res.get()	
			self.dict["ur_res"]=self.ir.ur_res.get()	
			self.dict["para_into"]=self.ir.para_into.get()	
			self.dict["para_from"]=self.ir.para_from.get()
			self.dict["demod_inf"]=self.ir.demod_inf.get()	
			self.dict["para_from_left"]=self.pm.para_from_left.get()	
			self.dict["para_from_right"]=self.pm.para_from_right.get()	
			self.dict["para_into_left"]=self.pm.para_into_left.get()	
			self.dict["para_into_right"]=self.pm.para_into_right.get()	
			self.dict["para_from_vars"]=self.pm.para_from_vars.get()	
			self.dict["para_into_vars"]=self.pm.para_into_vars.get()	
			self.dict["para_from_units_only"]=self.pm.para_from_units_only.get()	
			self.dict["para_into_units_only"]=self.pm.para_into_units_only.get()	
			self.dict["para_skip_skolem"]=self.pm.para_skip_skolem.get()	
			self.dict["para_ones_rule"]=self.pm.para_ones_rule.get()	
			self.dict["para_all"]=self.pm.para_all.get()	
			self.dict["detailed_history"]=self.hgc.detailed_history.get()	
			self.dict["order_history"]=self.hgc.order_history.get()	
			self.dict["unit_deletion"]=self.hgc.unit_deletion.get()	
			self.dict["delete_identical_nested_skolem"]=self.hgc.delete_identical_nested_skolem.get()	
			self.dict["sort_literals"]=self.hgc.sort_literals.get()	
			self.dict["for_sub"]=self.hgc.for_sub.get()	
			self.dict["back_sub"]=self.hgc.back_sub.get()	
			self.dict["factor"]=self.hgc.factor.get()	
			self.dict["demod_history"]=self.do.demod_history.get()
			self.dict["order_eq"]=self.do.order_eq.get()	
			self.dict["eq_units_both_ways"]=self.do.eq_units_both_ways.get()	
			self.dict["demod_linear"]=self.do.demod_linear.get()	
			self.dict["demod_out_in"]=self.do.demod_out_in.get()	
			self.dict["dynamic_demod"]=self.do.dynamic_demod.get()	
			self.dict["dynamic_demod_all"]=self.do.dynamic_demod_all.get()	
			self.dict["dynamic_demod_lex_dep"]=self.do.dynamic_demod_lex_dep.get()	
			self.dict["back_demod"]=self.do.back_demod.get()
			self.dict["knuth_bendix"]=self.do.knuth_bendix.get()	
			self.dict["lrpo"]=self.do.lrpo.get()	
			self.dict["lex_order_vars"]=self.do.lex_order_vars.get()
			self.dict["symbol_elim"]=self.do.symbol_elim.get()	
			self.dict["prolog_style_variables"]=self.ip.prolog_style_variables.get()	
			self.dict["simplify_fol"]=self.ip.simplify_fol.get()	
			self.dict["process_input"]=self.ip.process_input.get()	
			self.dict["check_arity"]=self.ip.check_arity.get()	
			self.dict["very_verbose"]=self.op.very_verbose.get()	
			self.dict["print_kept"]=self.op.print_kept.get()	
			self.dict["print_proofs"]=self.op.print_proofs.get()	
			self.dict["print_new_demod"]=self.op.print_new_demod.get()	
			self.dict["print_back_demod"]=self.op.print_back_demod.get()	
			self.dict["print_back_sub"]=self.op.print_back_sub.get()	
			self.dict["display_terms"]=self.op.display_terms.get()	
			self.dict["pretty_print"]=self.op.pretty_print.get()	
			self.dict["bird_print"]=self.op.bird_print.get()	
			self.dict["echo_included_files"]=self.op.echo_included_files.get()	
			self.dict["print_given"]=self.op.print_given.get()	
			self.dict["print_lists_at_end"]=self.op.print_lists_at_end.get()	
			self.dict["index_for_back_demod"]=self.ind.index_for_back_demod.get()	
			self.dict["for_sub_fpa"]=self.ind.for_sub_fpa.get()	
			self.dict["no_fapl"]=self.ind.no_fapl.get()	
			self.dict["no_fanl"]=self.ind.no_fanl.get()	
			self.dict["control_memory"]=self.misc.control_memory.get()	
			self.dict["order_hyper"]=self.misc.order_hyper.get()	
			self.dict["propositional"]=self.misc.propositional.get()	
			self.dict["really_delete_clauses"]=self.misc.really_delete_clauses.get()	
			self.dict["atom_wt_max_args"]=self.misc.atom_wt_max_args.get()	
			self.dict["term_wt_max_args"]=self.misc.term_wt_max_args.get()	
			self.dict["free_all_mem"]=self.misc.free_all_mem.get()

#			p_dict={}	
#			try:
#				i=eval(self.p_mon.report.get())
#				if i>=-1:
#					p_dict["report"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Output statistics...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Output statistics...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_src.max_seconds.get())
#				if i>=-1:
#					p_dict["max_seconds"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Terminate search ...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Terminate search ...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_src.max_gen.get())
#				if i>=-1:
#					p_dict["max_gen"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of generated Clauses...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of generated Clauses...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_src.max_kept.get())
#				if i>=-1:
#					p_dict["max_kept"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of kept Clauses...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of kept Clauses...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_src.max_given.get())
#				if i>=-1:
#					p_dict["max_given"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Terminate after n given clauses have been used'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Terminate after n given clauses have been used'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_src.max_mem.get())
#				if i>=-1:
#					p_dict["max_mem"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Maximum Memory Allocation...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Maximum Memory Allocation...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_genc.max_literals.get())
#				if i>=-1:
#					p_dict["max_literals"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of Literals...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of Literals...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_genc.max_weight.get())
#				p_dict["max_weight"]=i	
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Weight...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_genc.max_distinct_vars.get())
#				if i>=-1:
#					p_dict["max_distinct_vars"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of distinct Variables...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of distinct Variables...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_ind.fpa_literals.get())
#				if (i>=0 and i<=100):
#					p_dict["fpa_literals"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Indexing depth for Literals...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Indexing depth for Literals...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_ind.fpa_terms.get())
#				if (i>=0 and i<=100):
#					p_dict["fpa_terms"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Indexing depth for Terms...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Indexing depth for Terms...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_misc.pick_given_ratio.get())
#				if i>=-1:
#					p_dict["pick_given_ratio"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Select n given clauses...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Select n given clauses...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_misc.interrupt_given.get())
#				if i>=-1:
#					p_dict["interrupt_given"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Go into interactive mode...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Go into interactive mode...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_misc.demod_limit.get())
#				if i>=-1:
#					p_dict["demod_limit"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of rewrites...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Max Nr of rewrites...'")
#				self.dict["Error"]="T"
#				break
#			try:
#				i=eval(self.p_misc.max_proofs.get())
#				if i>=-1:
#					p_dict["max_proofs"]=i	
#				else:
#					tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Nr of proofs...'")
#					self.dict["Error"]="T"
#					break
#			except:
#				tkMessageBox.showwarning("Wrong Value","Wrong Value for 'Nr of proofs...'")
#				self.dict["Error"]="T"
#				break
#			self.dict["p_dict"]=p_dict

	###################################################################################
	#	show window - when distroyed destroy flag-group-objects and return dictionary of flag-settings	#
	###################################################################################
	
	def show(self,shw=""):
		if shw=="SHOW":
			self.top.deiconify()
			self.set_Var(self.last)
			self.top.wait_window()
			if self.dict["Cancel"]=="":
				tkMessageBox.showinfo("","Cancel")
				self.dict["Cancel"]="T"
		else:
			self.quit()
		return self.dict


