#!/usr/local/bin/python
import sys
import os
import string
import glob
import tkMessageBox
from Tkinter import *
from Tkconstants import *


###########################################################################################
###########################################################################################
##													##
##	CLASSES FOR OTTER-FLAGS GROUPS								##
##			classes:										##
##				main_loop								##
##				outpt									##
##				prnt									##
##				inference_rule								##
##				reduction								##
##				weight									##
##				skolemisation								##
##				calculus									##
##				system									##
##				deletion									##
##													##
##			flags and flag-names and values as in flags.c						##
##													##
###########################################################################################
###########################################################################################


class main_loop:
##########################################################################################
#Presents frame with flags for calculus choice								#
#		flags:											#
#			_CPara										#
#			_COrdPara									#
#			_CSupE										#
#			_CSupP										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.sos_queue=IntVar()
		self.sos_queue.set(0)
		self.sos_stack=IntVar()
		self.sos_stack.set(0)
		self.input_sos_first=IntVar()
		self.input_sos_first.set(0)
		self.interactive_given=IntVar()
		self.interactive_given.set(0)
		label01 = Label(self.frame, text="breadth-first search:")
		label02 = Label(self.frame, text="depth-first search:")
		label03 = Label(self.frame, text="first select input clauses as given clauses:")
		label04 = Label(self.frame, text="let user select given clauses:")
		label01.grid(row=0, column=0,sticky="E")
		label02.grid(row=1, column=0,sticky="E")
		label03.grid(row=2, column=0,sticky="E")
		label04.grid(row=3, column=0,sticky="E")
		radio011=Radiobutton(self.frame,text="on",variable=self.sos_queue,value=1)	
		radio012=Radiobutton(self.frame,text="off",variable=self.sos_queue,value=0)
		radio021=Radiobutton(self.frame,text="on",variable=self.sos_stack,value=1)
		radio022=Radiobutton(self.frame,text="off",variable=self.sos_stack,value=0)
		radio031=Radiobutton(self.frame,text="on",variable=self.input_sos_first,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.input_sos_first,value=0)
		radio041=Radiobutton(self.frame,text="on",variable=self.interactive_given,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.interactive_given,value=0)
		radio011.grid(row=0,column=1,sticky="W")
		radio012.grid(row=0,column=2,sticky="W")
		radio021.grid(row=1,column=1,sticky="W")
		radio022.grid(row=1,column=2,sticky="W")
		radio031.grid(row=2,column=1,sticky="W")
		radio032.grid(row=2,column=2,sticky="W")
		radio041.grid(row=3,column=1,sticky="W")
		radio042.grid(row=3,column=2,sticky="W")

class inference_rules:
##########################################################################################
#Presents frame with flags for screen output									#
#		flags:											#
#			_PSub										#
#			_DocSST									#
#			_DocDST									#
#			_PRew										#
#			_PCon										#
#			_PTaut										#
#			_PObv										#
#			_PSSi										#
#			_PSST										#
#			_DocProof									#
#			_PClR										#
#			_PDer										#
#			_PGiven										#
#			_PKept										#
#			_DocSplit									#
#			_PProblem									#
#			_PEmptyClause									#
#			_PStatistic									#
#			_PFlags										#
#			_DocFormulaeOnly								#
#			_PUnC										#
#			_PApplyDefs									#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.parent=parent
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.binary_res=IntVar()
		self.binary_res.set(0)
		self.hyper_res=IntVar()
		self.hyper_res.set(0)
		self.neg_hyper_res=IntVar()
		self.neg_hyper_res.set(0)
		self.ur_res=IntVar()
		self.ur_res.set(0)
		self.para_into=IntVar()
		self.para_into.set(0)
		self.para_from=IntVar()
		self.para_from.set(0)
		self.demod_inf=IntVar()
		self.demod_inf.set(0)

		label08 = Label(self.frame, text="Binary Resolution:")
		label10 = Label(self.frame, text="(positive) Hyperresolution:")
		label11 = Label(self.frame, text="negative Hyperresolution:")
		label12 = Label(self.frame, text="Unit-Resulting Resolution:")
		label13 = Label(self.frame, text="Paramodulation into the given clause:")
		label14 = Label(self.frame, text="Paramodulation from the given clause:")
		label15 = Label(self.frame, text="apply Demodulation as inference rule:")
		label08.grid(row=7, column=0,sticky="E")
		label10.grid(row=9, column=0,sticky="E")
		label11.grid(row=10, column=0,sticky="E")
		label12.grid(row=11, column=0,sticky="E")
		label13.grid(row=12, column=0,sticky="E")
		label14.grid(row=13, column=0,sticky="E")
		label15.grid(row=14, column=0,sticky="E")

		radio081=Radiobutton(self.frame,text="on",variable=self.binary_res,value=1,command=self.ask_binary_res)
		radio082=Radiobutton(self.frame,text="off",variable=self.binary_res,value=0)

		radio101=Radiobutton(self.frame,text="on",variable=self.hyper_res,value=1)
		radio102=Radiobutton(self.frame,text="off",variable=self.hyper_res,value=0)

		radio111=Radiobutton(self.frame,text="on",variable=self.neg_hyper_res,value=1)
		radio112=Radiobutton(self.frame,text="off",variable=self.neg_hyper_res,value=0)

		radio121=Radiobutton(self.frame,text="on",variable=self.ur_res,value=1)
		radio122=Radiobutton(self.frame,text="off",variable=self.ur_res,value=0)

		radio131=Radiobutton(self.frame,text="on",variable=self.para_into,value=1)
		radio132=Radiobutton(self.frame,text="off",variable=self.para_into,value=0)

		radio141=Radiobutton(self.frame,text="on",variable=self.para_from,value=0)
		radio142=Radiobutton(self.frame,text="off",variable=self.para_from,value=1)

		radio151=Radiobutton(self.frame,text="on",variable=self.demod_inf,value=1)
		radio152=Radiobutton(self.frame,text="off",variable=self.demod_inf,value=0)

		radio081.grid(row=7,column=1,sticky="W")
		radio082.grid(row=7,column=2,sticky="W")
		radio101.grid(row=9,column=1,sticky="W")
		radio102.grid(row=9,column=2,sticky="W")
		radio111.grid(row=10,column=1,sticky="W")
		radio112.grid(row=10,column=2,sticky="W")
		radio121.grid(row=11,column=1,sticky="W")
		radio122.grid(row=11,column=2,sticky="W")
		radio131.grid(row=12,column=1,sticky="W")
		radio132.grid(row=12,column=2,sticky="W")
		radio141.grid(row=13,column=1,sticky="W")
		radio142.grid(row=13,column=2,sticky="W")
		radio151.grid(row=14,column=1,sticky="W")
		radio152.grid(row=14,column=2,sticky="W")

	def ask_binary_res(self):
		if tkMessageBox.askokcancel("Set Flags","Flags 'factor' and 'unit_deletion' (group: Handling of generated clauses) are automatically set"):
			self.parent.hgc.unit_deletion.set(1)
			self.parent.hgc.factor.set(1)
		else:
			self.binary_res.set(0)

class paramodulation:
##########################################################################################
#Presents frame with flags for print to file									#
#		flags:											#
#			_FPModel									#
#			_FPDFGProof									#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.para_from_left=IntVar()
		self.para_from_left.set(1)
		self.para_from_right=IntVar()
		self.para_from_right.set(1)
		self.para_into_left=IntVar()
		self.para_into_left.set(1)
		self.para_into_right=IntVar()
		self.para_into_right.set(1)
		self.para_from_vars=IntVar()
		self.para_from_vars.set(0)
		self.para_into_vars=IntVar()
		self.para_into_vars.set(0)
		self.para_from_units_only=IntVar()
		self.para_from_units_only.set(0)
		self.para_into_units_only=IntVar()
		self.para_into_units_only.set(0)
		self.para_skip_skolem=IntVar()
		self.para_skip_skolem.set(0)
		self.para_ones_rule=IntVar()
		self.para_ones_rule.set(0)
		self.para_all=IntVar()
		self.para_all.set(0)
		label01 = Label(self.frame, text="... from left sides of equality literals:")
		label02 = Label(self.frame, text="... from right sides of equality literals:")
		label03 = Label(self.frame, text="... into left sides of equality literals:")
		label04 = Label(self.frame, text="... into right sides of equality literals:")
		label05 = Label(self.frame, text="... from variables:")
		label06 = Label(self.frame, text="... into variables:")
		label07 = Label(self.frame, text="... only if from-clause is unit (equality):")
		label08 = Label(self.frame, text="... only if into-clause is unit (equality):")
		label09 = Label(self.frame, text="... never into subterms of Skolem expressions:")
		label10 = Label(self.frame, text="... obeys the 1's rule:")
		label11 = Label(self.frame, justify=RIGHT, text="replace all occurences of the into-term\nwith the replacement-term:")
		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")
		label05.grid(row=5, column=0,sticky="E")
		label06.grid(row=6, column=0,sticky="E")
		label07.grid(row=7, column=0,sticky="E")
		label08.grid(row=8, column=0,sticky="E")
		label09.grid(row=9, column=0,sticky="E")
		label10.grid(row=10, column=0,sticky="E")
		label11.grid(row=11, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.para_from_left,value=1)
		radio012=Radiobutton(self.frame,text="off",variable=self.para_from_left,value=0)

		radio021=Radiobutton(self.frame,text="on",variable=self.para_from_right,value=1)
		radio022=Radiobutton(self.frame,text="off",variable=self.para_from_right,value=0)

		radio031=Radiobutton(self.frame,text="on",variable=self.para_into_left,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.para_into_left,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.para_into_right,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.para_into_right,value=0)

		radio051=Radiobutton(self.frame,text="on",variable=self.para_from_vars,value=1)
		radio052=Radiobutton(self.frame,text="off",variable=self.para_from_vars,value=0)

		radio061=Radiobutton(self.frame,text="on",variable=self.para_into_vars,value=1)
		radio062=Radiobutton(self.frame,text="off",variable=self.para_into_vars,value=0)

		radio071=Radiobutton(self.frame,text="on",variable=self.para_from_units_only,value=1)
		radio072=Radiobutton(self.frame,text="off",variable=self.para_from_units_only,value=0)

		radio081=Radiobutton(self.frame,text="on",variable=self.para_into_units_only,value=1)
		radio082=Radiobutton(self.frame,text="off",variable=self.para_into_units_only,value=0)

		radio091=Radiobutton(self.frame,text="on",variable=self.para_skip_skolem,value=1)
		radio092=Radiobutton(self.frame,text="off",variable=self.para_skip_skolem,value=0)

		radio101=Radiobutton(self.frame,text="on",variable=self.para_ones_rule,value=1)
		radio102=Radiobutton(self.frame,text="off",variable=self.para_ones_rule,value=0)

		radio111=Radiobutton(self.frame,text="on",variable=self.para_all,value=1)
		radio112=Radiobutton(self.frame,text="off",variable=self.para_all,value=0)

		radio011.grid(row=1,column=1,sticky="W")
		radio012.grid(row=1,column=2,sticky="W")
		radio021.grid(row=2,column=1,sticky="W")
		radio022.grid(row=2,column=2,sticky="W")
		radio031.grid(row=3,column=1,sticky="W")
		radio032.grid(row=3,column=2,sticky="W")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")
		radio051.grid(row=5,column=1,sticky="SW")
		radio052.grid(row=5,column=2,sticky="SW")
		radio061.grid(row=6,column=1,sticky="SW")
		radio062.grid(row=6,column=2,sticky="SW")
		radio071.grid(row=7,column=1,sticky="SW")
		radio072.grid(row=7,column=2,sticky="SW")
		radio081.grid(row=8,column=1,sticky="SW")
		radio082.grid(row=8,column=2,sticky="SW")
		radio091.grid(row=9,column=1,sticky="SW")
		radio092.grid(row=9,column=2,sticky="SW")
		radio101.grid(row=10,column=1,sticky="SW")
		radio102.grid(row=10,column=2,sticky="SW")
		radio111.grid(row=11,column=1,sticky="SW")
		radio112.grid(row=11,column=2,sticky="SW")

class handling_generated_clauses:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.detailed_history=IntVar()
		self.detailed_history.set(1)
		self.order_history=IntVar()
		self.order_history.set(0)
		self.unit_deletion=IntVar()
		self.unit_deletion.set(0)
		self.delete_identical_nested_skolem=IntVar()
		self.delete_identical_nested_skolem.set(0)
		self.sort_literals=IntVar()
		self.sort_literals.set(0)
		self.for_sub=IntVar()
		self.for_sub.set(1)
		self.back_sub=IntVar()
		self.back_sub.set(1)
		self.factor=IntVar()
		self.factor.set(0)
		label01 = Label(self.frame, justify=RIGHT, text="give positions of unified literals or terms\n(* bin res - inference rules\n* para from, para into - paramodulation):")
		label02 = Label(self.frame, justify=RIGHT, text="list nucleus first\n(hyperres, neg hyperres, UR-res - inference rules):")
		label03 = Label(self.frame, text="apply unit-deletion to newly generated clauses:")
		label04 = Label(self.frame, text="delete clauses with nested Skolem property:")
		label05 = Label(self.frame, justify=RIGHT, text="sort literals of newly generated clauses\n(negative,positve,answer):")
		label06 = Label(self.frame, text="forward subsumption:")
		label07 = Label(self.frame, text="back subsumption:")
		label08 = Label(self.frame, justify=RIGHT, text="apply factoring as simplification rule to\nnewly generated clauses and\nas inference rule to newly kept clauses:")

		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")
		label05.grid(row=5, column=0,sticky="E")
		label06.grid(row=6, column=0,sticky="E")
		label07.grid(row=7, column=0,sticky="E")
		label08.grid(row=8, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.detailed_history,value=1)
		radio012=Radiobutton(self.frame,text="off",variable=self.detailed_history,value=0)

		radio021=Radiobutton(self.frame,text="on",variable=self.order_history,value=1)
		radio022=Radiobutton(self.frame,text="off",variable=self.order_history,value=0)

		radio031=Radiobutton(self.frame,text="on",variable=self.unit_deletion,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.unit_deletion,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.delete_identical_nested_skolem,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.delete_identical_nested_skolem,value=0)

		radio051=Radiobutton(self.frame,text="on",variable=self.sort_literals,value=1)
		radio052=Radiobutton(self.frame,text="off",variable=self.sort_literals,value=0)

		radio061=Radiobutton(self.frame,text="on",variable=self.for_sub,value=1)
		radio062=Radiobutton(self.frame,text="off",variable=self.for_sub,value=0)

		radio071=Radiobutton(self.frame,text="on",variable=self.back_sub,value=1)
		radio072=Radiobutton(self.frame,text="off",variable=self.back_sub,value=0)

		radio081=Radiobutton(self.frame,text="on",variable=self.factor,value=1)
		radio082=Radiobutton(self.frame,text="off",variable=self.factor,value=0)

		radio011.grid(row=1,column=1,sticky="SW")
		radio012.grid(row=1,column=2,sticky="SW")
		radio021.grid(row=2,column=1,sticky="SW")
		radio022.grid(row=2,column=2,sticky="SW")
		radio031.grid(row=3,column=1,sticky="SW")
		radio032.grid(row=3,column=2,sticky="SW")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")
		radio051.grid(row=5,column=1,sticky="SW")
		radio052.grid(row=5,column=2,sticky="SW")
		radio061.grid(row=6,column=1,sticky="SW")
		radio062.grid(row=6,column=2,sticky="SW")
		radio071.grid(row=7,column=1,sticky="SW")
		radio072.grid(row=7,column=2,sticky="SW")
		radio081.grid(row=8,column=1,sticky="SW")
		radio082.grid(row=8,column=2,sticky="SW")

class demodulation_ordering:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.parent=parent
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.errors={}
		self.errors["lrpo"]="F"
		self.demod_history=IntVar()
		self.demod_history.set(1)
		self.order_eq=IntVar()
		self.order_eq.set(0)
		self.eq_units_both_ways=IntVar()
		self.eq_units_both_ways.set(0)
		self.demod_linear=IntVar()
		self.demod_linear.set(0)
		self.demod_out_in=IntVar()
		self.demod_out_in.set(0)
		self.dynamic_demod=IntVar()
		self.dynamic_demod.set(0)
		self.dynamic_demod_all=IntVar()
		self.dynamic_demod_all.set(1)
		self.dynamic_demod_lex_dep=IntVar()
		self.dynamic_demod_lex_dep.set(0)
		self.back_demod=IntVar()
		self.back_demod.set(0)
		self.knuth_bendix=IntVar()
		self.knuth_bendix.set(0)
		self.lrpo=IntVar()
		self.lrpo.set(0)
		self.lex_order_vars=IntVar()
		self.lex_order_vars.set(0)
		self.symbol_elim=IntVar()
		self.symbol_elim.set(0)
		label01 = Label(self.frame, text="include ID numbers of demulators in derivation history:")
		label02 = Label(self.frame, text="flip equalities if right side is heavier:")
		label03 = Label(self.frame, text="store unit equality clauses in both directions:")
		label04 = Label(self.frame, text="no demodulation indexing:")
		label05 = Label(self.frame, text="demodulate outside-in,left-to-right:")
		label06 = Label(self.frame, text="make SOME newly kept equalities into demodulators:")
		label07 = Label(self.frame, justify=RIGHT, text="attempt to make ALL newly kept equalities\ninto demodulators:")
		label08 = Label(self.frame, text="dynamic demodulators may be lex- or LRPO-dependent:")
		label09 = Label(self.frame, text="apply back demodulation:")
		label10 = Label(self.frame, text="search behaves like a Knuth-Bendix completion procedure:")
		label11 = Label(self.frame, text="use lexicographic recursive path ordering:")
		label12 = Label(self.frame, text="use lexical ordering as total order on terms:")
		label13 = Label(self.frame, justify=RIGHT, text="if possible orient new demodulators,\nso that func-symb. are eliminated:")

		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")
		label05.grid(row=5, column=0,sticky="E")
		label06.grid(row=6, column=0,sticky="E")
		label07.grid(row=7, column=0,sticky="E")
		label08.grid(row=8, column=0,sticky="E")
		label09.grid(row=9, column=0,sticky="E")
		label10.grid(row=10, column=0,sticky="E")
		label11.grid(row=11, column=0,sticky="E")
		label12.grid(row=12, column=0,sticky="E")
		label13.grid(row=13, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.demod_history,value=1)
		radio012=Radiobutton(self.frame,text="off",variable=self.demod_history,value=0)

		radio021=Radiobutton(self.frame,text="on",variable=self.order_eq,value=1)
		radio022=Radiobutton(self.frame,text="off",variable=self.order_eq,value=0)

		radio031=Radiobutton(self.frame,text="on",variable=self.eq_units_both_ways,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.eq_units_both_ways,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.demod_linear,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.demod_linear,value=0)

		radio051=Radiobutton(self.frame,text="on",variable=self.demod_out_in,value=1)
		radio052=Radiobutton(self.frame,text="off",variable=self.demod_out_in,value=0)

		radio061=Radiobutton(self.frame,text="on",variable=self.dynamic_demod,value=1,command=self.ask_dynamic_demod)
		radio062=Radiobutton(self.frame,text="off",variable=self.dynamic_demod,value=0)

		radio071=Radiobutton(self.frame,text="on",variable=self.dynamic_demod_all,value=1,command=self.ask_dynamic_demod_all)
		radio072=Radiobutton(self.frame,text="off",variable=self.dynamic_demod_all,value=0)

		radio081=Radiobutton(self.frame,text="on",variable=self.dynamic_demod_lex_dep,value=1)
		radio082=Radiobutton(self.frame,text="off",variable=self.dynamic_demod_lex_dep,value=0)

		radio091=Radiobutton(self.frame,text="on",variable=self.back_demod,value=1,command=self.ask_back_demod)
		radio092=Radiobutton(self.frame,text="off",variable=self.back_demod,value=0)

		radio101=Radiobutton(self.frame,text="on",variable=self.knuth_bendix,value=1,command=self.ask_knuth_bendix)
		radio102=Radiobutton(self.frame,text="off",variable=self.knuth_bendix,value=0)

		radio111=Radiobutton(self.frame,text="on",variable=self.lrpo,value=1,command=self.check_lex_order_vars)
		radio112=Radiobutton(self.frame,text="off",variable=self.lrpo,value=0,command=self.check_lex_order_vars)

		radio121=Radiobutton(self.frame,text="on",variable=self.lex_order_vars,value=1,command=self.check_lrpo)
		radio122=Radiobutton(self.frame,text="off",variable=self.lex_order_vars,value=0,command=self.check_lrpo)

		radio131=Radiobutton(self.frame,text="on",variable=self.symbol_elim,value=1)
		radio132=Radiobutton(self.frame,text="off",variable=self.symbol_elim,value=0)

		radio011.grid(row=1,column=1,sticky="SW")
		radio012.grid(row=1,column=2,sticky="SW")
		radio021.grid(row=2,column=1,sticky="SW")
		radio022.grid(row=2,column=2,sticky="SW")
		radio031.grid(row=3,column=1,sticky="SW")
		radio032.grid(row=3,column=2,sticky="SW")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")
		radio051.grid(row=5,column=1,sticky="SW")
		radio052.grid(row=5,column=2,sticky="SW")
		radio061.grid(row=6,column=1,sticky="SW")
		radio062.grid(row=6,column=2,sticky="SW")
		radio071.grid(row=7,column=1,sticky="SW")
		radio072.grid(row=7,column=2,sticky="SW")
		radio081.grid(row=8,column=1,sticky="SW")
		radio082.grid(row=8,column=2,sticky="SW")
		radio091.grid(row=9,column=1,sticky="SW")
		radio092.grid(row=9,column=2,sticky="SW")
		radio101.grid(row=10,column=1,sticky="SW")
		radio102.grid(row=10,column=2,sticky="SW")
		radio111.grid(row=11,column=1,sticky="SW")
		radio112.grid(row=11,column=2,sticky="SW")
		radio121.grid(row=12,column=1,sticky="SW")
		radio122.grid(row=12,column=2,sticky="SW")
		radio131.grid(row=13,column=1,sticky="SW")
		radio132.grid(row=13,column=2,sticky="SW")

	def ask_dynamic_demod(self):
		if tkMessageBox.askokcancel("Set Flags","Flag 'flip equalities..' will automatically be set"):
			self.order_eq.set(1)
		else:
			self.dynamic_demod.set(0)

	def ask_dynamic_demod_all(self):
		if tkMessageBox.askokcancel("Set Flags","Flags 'flip equalities..' and 'make SOME newly kept equalities into demodulators' automatically set"):
			self.order_eq.set(1)
			self.dynamic_demod.set(1)
		else:
			self.dynamic_demod_all.set(0)

	def ask_back_demod(self):
		if tkMessageBox.askokcancel("Set Flags","Flags 'flip equalities..' and 'make SOME newly kept equalities into demodulators' automatically set"):
			self.order_eq.set(1)
			self.dynamic_demod.set(1)
		else:
			self.back_demod.set(0)

	def ask_knuth_bendix(self):
		if tkMessageBox.askokcancel("Set Flags","These Flags will automatically be SET:\n\011'Paramodulation into the given clause'\n\011'Paramodulation from the given clause' (group 'Inference Rules')\n\011'... from left sides of equality literals'\n\011'... into left sides of equality literals'\n\011'... from variables'\n\011'... into variables' (group 'Paramodulation')\n\011'process input 'usable' and 'sos' clauses as if generated by inference rule' (group 'Input')\n\011'store unit equality clauses in both directions'\n\011'attempt to make ALL newly kept equalities into demodulators'\n\011'apply back demodulation'\n\011'use lexicographic recursive path ordering'\n\nThese Flags will automatically be CLEARED:\n\011'... from right sides of equality literals'\n\011'... into right sides of equality literals' (group 'Paramodulation')"):
			self.parent.ir.para_from.set(1)
			self.parent.ir.para_into.set(1)
			self.parent.pm.para_from_left.set(1)
			self.parent.pm.para_from_right.set(0)
			self.parent.pm.para_into_left.set(1)
			self.parent.pm.para_into_right.set(0)
			self.parent.pm.para_from_vars.set(1)
			self.eq_units_both_ways.set(1)
			self.dynamic_demod_all.set(1)
			self.back_demod.set(1)
			self.lrpo.set(1)
			self.parent.ip.process_input.set(1)
		else:
			self.knuth_bendix.set(0)

	def check_lrpo(self):
		if self.lrpo.get()==1:
			tkMessageBox.showinfo("Ordering","your choice has no effect on demodulation, because 'lexicographic recursive path ordering' is set")

	def check_lex_order_vars(self):
		if self.lrpo.get()==1:
			if self.lex_order_vars.get()==1:
				if self.errors["lrpo"]=="F":
					tkMessageBox.showinfo("Ordering","'use lexical ordering as total order on terms' has no effect on demodulation, because 'lexicographic recursive path ordering' is set")
					self.errors["lrpo"]="T"
			else:
				self.errors["lrpo"]="F"
		else:
			self.errors["lrpo"]="F"

class input:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.errors={}
		self.errors["simplify_fol"]="F"
		self.prolog_style_variables=IntVar()
		self.prolog_style_variables.set(0)
		self.simplify_fol=IntVar()
		self.simplify_fol.set(1)
		self.process_input=IntVar()
		self.process_input.set(0)
		self.check_arity=IntVar()
		self.check_arity.set(1)
		label01 = Label(self.frame, text="Prolog-style variables:")
		label02 = Label(self.frame, justify=RIGHT, text="attempt some propositional simplification when converting\ninput first-order formulas into clauses:")
		label03 = Label(self.frame, justify=RIGHT, text="process input 'usable' and 'sos' clauses\nas if generated by inference rule:")
		label04 = Label(self.frame, text="variable arities not permitted:")

		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.prolog_style_variables,value=1)
		radio012=Radiobutton(self.frame,text="off",variable=self.prolog_style_variables,value=0)

		radio021=Radiobutton(self.frame,text="on",variable=self.simplify_fol,value=1,command=self.check_process_input)
		radio022=Radiobutton(self.frame,text="off",variable=self.simplify_fol,value=0,command=self.check_process_input)

		radio031=Radiobutton(self.frame,text="on",variable=self.process_input,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.process_input,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.check_arity,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.check_arity,value=0)

		radio011.grid(row=1,column=1,sticky="SW")
		radio012.grid(row=1,column=2,sticky="SW")
		radio021.grid(row=2,column=1,sticky="SW")
		radio022.grid(row=2,column=2,sticky="SW")
		radio031.grid(row=3,column=1,sticky="SW")
		radio032.grid(row=3,column=2,sticky="SW")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")

	def check_process_input(self):
		if self.simplify_fol.get()==1:
			if self.process_input.get()==0:
				if self.errors["simplify_fol"]=="F":
					tkMessageBox.showinfo("Set Flags","If simplification detects a refutation, it will only be recognized if 'process input...' is set")
					self.errors["simplify_fol"]="T"
			else:
				self.errors["simplify_fol"]="F"
		else:
			self.errors["simplify_fol"]="F"

class output:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.parent=parent
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.errors={}
		self.errors["print_new_demod"]="F"
		self.errors["print_back_demod"]="F"
		self.errors["print_back_sub"]="F"
		self.very_verbose=IntVar()
		self.very_verbose.set(0)
		self.print_kept=IntVar()
		self.print_kept.set(1)
		self.print_proofs=IntVar()
		self.print_proofs.set(1)
		self.print_new_demod=IntVar()
		self.print_new_demod.set(1)
		self.print_back_demod=IntVar()
		self.print_back_demod.set(1)
		self.print_back_sub=IntVar()
		self.print_back_sub.set(1)
		self.display_terms=IntVar()
		self.display_terms.set(0)
		self.pretty_print=IntVar()
		self.pretty_print.set(0)
		self.bird_print=IntVar()
		self.bird_print.set(0)
		self.echo_included_files=IntVar()
		self.echo_included_files.set(1)
		self.print_given=IntVar()
		self.print_given.set(1)
		self.print_lists_at_end=IntVar()
		self.print_lists_at_end.set(0)

		label01 = Label(self.frame, justify=RIGHT, text="print tremendous amount of info\nabout processing of generated clauses:")
		label02 = Label(self.frame, text="print new clauses if they are retained:")
		label03 = Label(self.frame, text="print all proofs found:")
		label04 = Label(self.frame, text="print demulators adjoined during search:")
		label05 = Label(self.frame, text="print clauses as they are back-demodulated:")
		label06 = Label(self.frame, text="print back-subsumed clauses:")
		label07 = Label(self.frame, text="print clauses and terms in pure prefix form:")
		label08 = Label(self.frame, text="print clauses in an indented form:")
		label09 = Label(self.frame, justify=RIGHT, text="print terms constructed with binary functions\nin combinatory logic notation:")
		label10 = Label(self.frame, text="print input files included with include-command:")
		label11 = Label(self.frame, text="print clauses when they become given:")
		label12 = Label(self.frame, text="print 'usable', 'sos' and 'demodulators' at end of search:")

		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")
		label05.grid(row=5, column=0,sticky="E")
		label06.grid(row=6, column=0,sticky="E")
		label07.grid(row=7, column=0,sticky="E")
		label08.grid(row=8, column=0,sticky="E")
		label09.grid(row=9, column=0,sticky="E")
		label10.grid(row=10, column=0,sticky="E")
		label11.grid(row=11, column=0,sticky="E")
		label12.grid(row=12, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.very_verbose,value=1)
		radio012=Radiobutton(self.frame,text="off",variable=self.very_verbose,value=0)

		radio021=Radiobutton(self.frame,text="on",variable=self.print_kept,value=1)
		radio022=Radiobutton(self.frame,text="off",variable=self.print_kept,value=0)

		radio031=Radiobutton(self.frame,text="on",variable=self.print_proofs,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.print_proofs,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.print_new_demod,value=1,command=self.check_dynamic_demod)
		radio042=Radiobutton(self.frame,text="off",variable=self.print_new_demod,value=0,command=self.check_dynamic_demod)

		radio051=Radiobutton(self.frame,text="on",variable=self.print_back_demod,value=1,command=self.check_back_demod)
		radio052=Radiobutton(self.frame,text="off",variable=self.print_back_demod,value=0,command=self.check_back_demod)

		radio061=Radiobutton(self.frame,text="on",variable=self.print_back_sub,value=1,command=self.check_back_sub)
		radio062=Radiobutton(self.frame,text="off",variable=self.print_back_sub,value=0,command=self.check_back_sub)

		radio071=Radiobutton(self.frame,text="on",variable=self.display_terms,value=1)
		radio072=Radiobutton(self.frame,text="off",variable=self.display_terms,value=0)

		radio081=Radiobutton(self.frame,text="on",variable=self.pretty_print,value=1)
		radio082=Radiobutton(self.frame,text="off",variable=self.pretty_print,value=0)

		radio091=Radiobutton(self.frame,text="on",variable=self.bird_print,value=1)
		radio092=Radiobutton(self.frame,text="off",variable=self.bird_print,value=0)

		radio101=Radiobutton(self.frame,text="on",variable=self.echo_included_files,value=1)
		radio102=Radiobutton(self.frame,text="off",variable=self.echo_included_files,value=0)

		radio111=Radiobutton(self.frame,text="on",variable=self.print_given,value=1)
		radio112=Radiobutton(self.frame,text="off",variable=self.print_given,value=0)

		radio121=Radiobutton(self.frame,text="on",variable=self.print_lists_at_end,value=1)
		radio122=Radiobutton(self.frame,text="off",variable=self.print_lists_at_end,value=0)

		radio011.grid(row=1,column=1,sticky="SW")
		radio012.grid(row=1,column=2,sticky="SW")
		radio021.grid(row=2,column=1,sticky="SW")
		radio022.grid(row=2,column=2,sticky="SW")
		radio031.grid(row=3,column=1,sticky="SW")
		radio032.grid(row=3,column=2,sticky="SW")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")
		radio051.grid(row=5,column=1,sticky="SW")
		radio052.grid(row=5,column=2,sticky="SW")
		radio061.grid(row=6,column=1,sticky="SW")
		radio062.grid(row=6,column=2,sticky="SW")
		radio071.grid(row=7,column=1,sticky="SW")
		radio072.grid(row=7,column=2,sticky="SW")
		radio081.grid(row=8,column=1,sticky="SW")
		radio082.grid(row=8,column=2,sticky="SW")
		radio091.grid(row=9,column=1,sticky="SW")
		radio092.grid(row=9,column=2,sticky="SW")
		radio101.grid(row=10,column=1,sticky="SW")
		radio102.grid(row=10,column=2,sticky="SW")
		radio111.grid(row=11,column=1,sticky="SW")
		radio112.grid(row=11,column=2,sticky="SW")
		radio121.grid(row=12,column=1,sticky="SW")
		radio122.grid(row=12,column=2,sticky="SW")

	def check_dynamic_demod(self):
		if self.print_new_demod.get()==1:
			if (self.parent.do.dynamic_demod.get()==0 and self.parent.do.dynamic_demod_all.get()==0):	
				if self.errors["print_new_demod"]=="F":
					tkMessageBox.showinfo("can not print - deactivated","Dynamic demodulation not activated (group: Demodulation and Ordering)")
					self.errors["print_new_demod"]="T"
			else:
				self.errors["print_new_demod"]="F"
		else:
			self.errors["print_new_demod"]="F"

	def check_back_demod(self):
		if self.print_back_demod.get()==1:
			if (self.parent.do.back_demod.get()==0):
				if self.errors["print_back_demod"]=="F":
					tkMessageBox.showinfo("can not print - deactivated","Back demodulation not activated (group: Demodulation and Ordering)")
					self.errors["print_back_demod"]="T"
			else:
				self.errors["print_back_demod"]="F"
		else:
			self.errors["print_back_demod"]="F"

	def check_back_sub(self):
		if self.print_back_sub.get()==1:
			if (self.parent.hgc.back_sub.get()==0):
				if self.errors["print_back_sub"]=="F":
					tkMessageBox.showinfo("can not print - deactivated","Backward Subsumption not activated (group: Handling Generated Clauses)")
					self.errors["print_back_sub"]="T"
			else:
				self.errors["print_back_sub"]="F"
		else:
			self.errors["print_back_sub"]="F"

class indexing:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.errors={}
		self.errors["back_demod"]="F"
		self.index_for_back_demod=IntVar()
		self.index_for_back_demod.set(1)
		self.for_sub_fpa=IntVar()
		self.for_sub_fpa.set(0)
		self.no_fapl=IntVar()
		self.no_fapl.set(0)
		self.no_fanl=IntVar()
		self.no_fanl.set(0)
		label01 = Label(self.frame, justify=RIGHT, text="index all nonvariable terms in all clauses\nto be quickly retrieved\n(flag for back demodulation -\nuses a lot of memory!, but much faster):")
		label02 = Label(self.frame, text="indexing for forward subsumption:")
		label03 = Label(self.frame, justify=RIGHT, text="positive literals not indexed\nfor unit conflict or back subsumption:")
		label04 = Label(self.frame, justify=RIGHT, text="negative literals not indexed\nfor unit conflict or back subsumption:")

		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.index_for_back_demod,value=1,command=self.check_back_demod)
		radio012=Radiobutton(self.frame,text="off",variable=self.index_for_back_demod,value=0,command=self.check_back_demod)

		radio021=Radiobutton(self.frame,text="FPA",variable=self.for_sub_fpa,value=1)
		radio022=Radiobutton(self.frame,text="Discrimination tree",variable=self.for_sub_fpa,value=0)

		radio031=Radiobutton(self.frame,text="on",variable=self.no_fapl,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.no_fapl,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.no_fanl,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.no_fanl,value=0)

		radio011.grid(row=1,column=1,sticky="SW")
		radio012.grid(row=1,column=2,sticky="SW")
		radio021.grid(row=2,column=1,sticky="SW")
		radio022.grid(row=2,column=2,sticky="SW")
		radio031.grid(row=3,column=1,sticky="SW")
		radio032.grid(row=3,column=2,sticky="SW")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")

	def check_back_demod(self):
		if self.index_for_back_demod.get()==1:
			if self.parent.do.back_demod.get()==0:
				if self.errors["back_demod"]=="F":
					tkMessageBox.showinfo("Set Flags","back demodulation not activated (group: Demodulation and Ordering)")
					self.errors["back_demod"]="T"
			else:
				self.errors["back_demod"]="F"
		else:
			self.errors["back_demod"]="F"


class miscellaneous:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.control_memory=IntVar()
		self.control_memory.set(0)
		self.order_hyper=IntVar()
		self.order_hyper.set(1)
		self.propositional=IntVar()
		self.propositional.set(0)
		self.really_delete_clauses=IntVar()
		self.really_delete_clauses.set(0)
		self.atom_wt_max_args=IntVar()
		self.atom_wt_max_args.set(0)
		self.term_wt_max_args=IntVar()
		self.term_wt_max_args.set(0)
		self.free_all_mem=IntVar()
		self.free_all_mem.set(0)
		label01 = Label(self.frame, text="automatic memory control feature:")
		label02 = Label(self.frame, justify=RIGHT, text="use ordering strategy for\nhyper res. and neg. hyper res.:")
		label03 = Label(self.frame, justify=RIGHT, text="Only if all clauses are propositional -\nmakes optimizations:")
		label04 = Label(self.frame, justify=RIGHT, text="realy delete clauses\n(can't be printed in proof!):")
		label05 = Label(self.frame, justify=RIGHT, text="if no template matches the atom,\natom-weight is:")
		label06 = Label(self.frame, justify=RIGHT, text="if no template matches the term,\nterm-weight is:")
		label07 = Label(self.frame, justify=RIGHT, text="at end of search return\nmost dynamically allocated memory\nto memory managers:")

		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=2, column=0,sticky="E")
		label03.grid(row=3, column=0,sticky="E")
		label04.grid(row=4, column=0,sticky="E")
		label05.grid(row=5, column=0,sticky="E")
		label06.grid(row=6, column=0,sticky="E")
		label07.grid(row=7, column=0,sticky="E")

		radio011=Radiobutton(self.frame,text="on",variable=self.control_memory,value=1)
		radio012=Radiobutton(self.frame,text="off",variable=self.control_memory,value=0)

		radio021=Radiobutton(self.frame,text="on",variable=self.order_hyper,value=1)
		radio022=Radiobutton(self.frame,text="off",variable=self.order_hyper,value=0)

		radio031=Radiobutton(self.frame,text="on",variable=self.propositional,value=1)
		radio032=Radiobutton(self.frame,text="off",variable=self.propositional,value=0)

		radio041=Radiobutton(self.frame,text="on",variable=self.really_delete_clauses,value=1)
		radio042=Radiobutton(self.frame,text="off",variable=self.really_delete_clauses,value=0)

		radio051=Radiobutton(self.frame,justify=LEFT, text="1+\nmax_wt_args",variable=self.atom_wt_max_args,value=1)
		radio052=Radiobutton(self.frame,justify=LEFT, text="1+\nsum_wt_args",variable=self.atom_wt_max_args,value=0)

		radio061=Radiobutton(self.frame,justify=LEFT, text="1+\nmax_wt_args",variable=self.term_wt_max_args,value=1)
		radio062=Radiobutton(self.frame,justify=LEFT, text="1+\nsum_wt_args",variable=self.term_wt_max_args,value=0)

		radio071=Radiobutton(self.frame,text="on",variable=self.free_all_mem,value=1)
		radio072=Radiobutton(self.frame,text="off",variable=self.free_all_mem,value=0)

		radio011.grid(row=1,column=1,sticky="SW")
		radio012.grid(row=1,column=2,sticky="SW")
		radio021.grid(row=2,column=1,sticky="SW")
		radio022.grid(row=2,column=2,sticky="SW")
		radio031.grid(row=3,column=1,sticky="SW")
		radio032.grid(row=3,column=2,sticky="SW")
		radio041.grid(row=4,column=1,sticky="SW")
		radio042.grid(row=4,column=2,sticky="SW")
		radio051.grid(row=5,column=1,sticky="SW")
		radio052.grid(row=5,column=2,sticky="SW")
		radio061.grid(row=6,column=1,sticky="SW")
		radio062.grid(row=6,column=2,sticky="SW")
		radio071.grid(row=7,column=1,sticky="SW")
		radio072.grid(row=7,column=2,sticky="SW")

class p_monitoring_progress:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.report=StringVar()
		self.report.set("-1")
		label01 = Label(self.frame, text="output statistics every:")
		label02 = Label(self.frame, text="seconds (range [-1 ...]):")
		label01.grid(row=1, column=0,sticky="E")
		label02.grid(row=1, column=2,sticky="E")

		self.reportEntry=Entry(self.frame,textvariable=self.report,width=6)
		self.reportEntry.grid(row=1,column=1,pady=2)

class p_search_limits:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.max_seconds=StringVar()
		self.max_seconds.set("-1")
		self.max_gen=StringVar()
		self.max_gen.set("-1")
		self.max_kept=StringVar()
		self.max_kept.set("-1")
		self.max_given=StringVar()
		self.max_given.set("-1")
		self.max_mem=StringVar()
		self.max_mem.set("-1")
		label011 = Label(self.frame, text="terminate search after about")
		label012 = Label(self.frame, text="CPU seconds (range [-1 ...])")
		label021 = Label(self.frame, text="terminate search after about")
		label022 = Label(self.frame, justify=RIGHT, text="clauses have been generated\n(range [-1 ...])")
		label031 = Label(self.frame, text="terminate search after about")
		label032 = Label(self.frame, justify=RIGHT, text="clauses have been kept\n(range [-1 ...])")
		label041 = Label(self.frame, text="terminate search after")
		label042 = Label(self.frame, justify=RIGHT,text="given clauses have been used\n(range [-1 ...])")
		label051 = Label(self.frame, text="terminate search before more than")
		label052 = Label(self.frame, justify=RIGHT, text="kb memory have been\ndynamically allocated\n(range [-1 ...])")
		label011.grid(row=1, column=0,sticky="E")
		label012.grid(row=1, column=2,sticky="SW")
		label021.grid(row=2, column=0,sticky="E")
		label022.grid(row=2, column=2,sticky="SW")
		label031.grid(row=3, column=0,sticky="E")
		label032.grid(row=3, column=2,sticky="SW")
		label041.grid(row=4, column=0,sticky="E")
		label042.grid(row=4, column=2,sticky="SW")
		label051.grid(row=5, column=0,sticky="E")
		label052.grid(row=5, column=2,sticky="SW")

		self.max_secEntry=Entry(self.frame,textvariable=self.max_seconds,width=6)
		self.max_secEntry.grid(row=1,column=1,pady=2)
		self.max_genEntry=Entry(self.frame,textvariable=self.max_gen,width=6)
		self.max_genEntry.grid(row=2,column=1,pady=2)
		self.max_keptEntry=Entry(self.frame,textvariable=self.max_kept,width=6)
		self.max_keptEntry.grid(row=3,column=1,pady=2)
		self.max_givenEntry=Entry(self.frame,textvariable=self.max_given,width=6)
		self.max_givenEntry.grid(row=4,column=1,pady=2)
		self.max_memEntry=Entry(self.frame,textvariable=self.max_mem,width=6)
		self.max_memEntry.grid(row=5,column=1,pady=2)

class p_gen_clause_limits:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.max_literals=StringVar()
		self.max_literals.set("-1")
		self.max_weight=StringVar()
		self.max_weight.set("-1")
		self.max_distinct_vars=StringVar()
		self.max_distinct_vars.set("-1")
		label011 = Label(self.frame, text="discard new clauses, if they contain more than")
		label012 = Label(self.frame, justify=LEFT, text="literals\n(range [-1 ...])")
		label021 = Label(self.frame, text="discard new clauses, if they weigh more than")
		label022 = Label(self.frame, text="(range [-1 ...])")
		label031 = Label(self.frame, text="discard new clauses, if they contain more than")
		label032 = Label(self.frame, justify=RIGHT, text="distinct variables\n(range [-1 ...])")
		label011.grid(row=1, column=0,sticky="E")
		label012.grid(row=1, column=2,sticky="SW")
		label021.grid(row=2, column=0,sticky="E")
		label022.grid(row=2, column=2,sticky="SW")
		label031.grid(row=3, column=0,sticky="E")
		label032.grid(row=3, column=2,sticky="SW")

		self.max_litEntry=Entry(self.frame,textvariable=self.max_literals,width=6)
		self.max_litEntry.grid(row=1,column=1,pady=2)
		self.max_wtEntry=Entry(self.frame,textvariable=self.max_weight,width=6)
		self.max_wtEntry.grid(row=2,column=1,pady=2)
		self.max_dvEntry=Entry(self.frame,textvariable=self.max_distinct_vars,width=6)
		self.max_dvEntry.grid(row=3,column=1,pady=2)

class p_indexing:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.fpa_literals=StringVar()
		self.fpa_literals.set("8")
		self.fpa_terms=StringVar()
		self.fpa_terms.set("8")
		label011 = Label(self.frame, text="FPA indexing depth for literals is")
		label012 = Label(self.frame, text="(range [0 ... 100]):")
		label021 = Label(self.frame, text="FPA indexing depth for terms is")
		label022 = Label(self.frame, text="(range [0 ... 100]):")
		label011.grid(row=1, column=0,sticky="E")
		label012.grid(row=1, column=2,sticky="SW")
		label021.grid(row=2, column=0,sticky="E")
		label022.grid(row=2, column=2,sticky="SW")

		self.fpa_litEntry=Entry(self.frame,textvariable=self.fpa_literals,width=6)
		self.fpa_litEntry.grid(row=1,column=1,pady=2)
		self.fpa_termEntry=Entry(self.frame,textvariable=self.fpa_terms,width=6)
		self.fpa_termEntry.grid(row=2,column=1,pady=2)

class p_miscellaneous:
##########################################################################################
#Presents frame with flags for choose inference rules								#
#		flags:											#
#			_IEmS										#
#			_ISoR										#
#			_IEqR										#
#			_IEqF										#
#			_IMPm										#
#			_ISpR										#
#			_ISpL										#
#			_IGeR										#
#			_IGeF										#
#			_IBUR										#
#			_IUnR										#
#			_IOpM										#
#			_ISPm										#
#			_ISHy										#
#			_IOHy										#
#			_IDEF										#
#		methods:										#
#			__init__(self,parent=None)							#
#			show(self)									#
#			hide(self)									#
##########################################################################################
	def __init__(self,parent=None,parent_frame=None):
		self.frame=Frame(parent_frame,bd=3,relief=RIDGE)
		self.parent=parent
		self.pick_given_ratio=StringVar()
		self.pick_given_ratio.set("-1")
		self.interrupt_given=StringVar()
		self.interrupt_given.set("-1")
		self.demod_limit=StringVar()
		self.demod_limit.set("1000")
		self.max_proofs=StringVar()
		self.max_proofs.set("1")
		label011 = Label(self.frame, text="select")
		label012 = Label(self.frame, justify=RIGHT, text="given clauses by weight\n(range [-1 ...])")
		label021 = Label(self.frame, text="go into interactive mode after")
		label022 = Label(self.frame, justify=RIGHT, text="given clauses have been used\n(range [-1 ...])")
		label031 = Label(self.frame, text="maximum number of rewrites")
		label032 = Label(self.frame, text="(range [-1 ...]):")
		label041 = Label(self.frame, text="try to find")
		label042 = Label(self.frame, text="proofs (range [-1 ...]):")
		label011.grid(row=1, column=0,sticky="E")
		label012.grid(row=1, column=2,sticky="SW")
		label021.grid(row=2, column=0,sticky="E")
		label022.grid(row=2, column=2,sticky="SW")
		label031.grid(row=3, column=0,sticky="E")
		label032.grid(row=3, column=2,sticky="SW")
		label041.grid(row=4, column=0,sticky="E")
		label042.grid(row=4, column=2,sticky="SW")

		self.pick_given_ratioEntry=Entry(self.frame,textvariable=self.pick_given_ratio,width=6)
		self.pick_given_ratioEntry.grid(row=1,column=1,pady=2)
		self.interrupt_givenEntry=Entry(self.frame,textvariable=self.interrupt_given,width=6)
		self.interrupt_givenEntry.grid(row=2,column=1,pady=2)
		self.demod_limitEntry=Entry(self.frame,textvariable=self.demod_limit,width=6)
		self.demod_limitEntry.grid(row=3,column=1,pady=2)
		self.max_proofsEntry=Entry(self.frame,textvariable=self.max_proofs,width=6)
		self.max_proofsEntry.grid(row=4,column=1,pady=2)



