#!/usr/local/bin/python
import sys
import os
import string
import glob
import tkMessageBox
from Tkinter import *
from Tkconstants import *
from FileDialog import *  #LoadFileDialog
#from FileDialog import SaveFileDialog
from io import *


###########################################################################################
###########################################################################################
##													##
##	CLASSES TO SET PREFERENCES FOR AUTOMOD							##
##		classes:											##
##			SetDirectories									##
##													##
###########################################################################################
###########################################################################################



class SetDirectories:
##########################################################################################
#	window to set working-directories for Main, SPASS-Flags, Flotter-Flags, Models				#
#		methods:										#
#			__init__(self,parent=None)							#
#			quit(self) ... write new directories to setting-file and quit application			#									#
#			cancel(self) ... quit application							#
#			show(self)									#
##########################################################################################
	def __init__(self,parent=None):
	###################################################################################
	#	initialises window										#
	###################################################################################
		self.top = Toplevel(parent)
		self.top.title("PREFERENCES - Set Directories")
		self.frame=Frame(self.top)
		self.frame.pack(side=BOTTOM)
		self.menu_frame=Frame(self.top,relief=RAISED,bd=2)
		self.menu_frame.pack(side=TOP,fill=X)
		#	menu				#
		FileButton=Menubutton(self.menu_frame,text="File")
		FileButton.pack(side=LEFT)
		self.FileMenu=Menu(FileButton)
		self.FileMenu.add_command(label="OK",command=self.quit)
		FileButton["menu"]=self.FileMenu

		self.MainDict=StringVar()
		self.Main_Directory=Entry(self.frame,textvariable=self.MainDict,width=40)
		self.SpassDict=StringVar()
		self.Spass_Directory=Entry(self.frame,textvariable=self.SpassDict,width=40)
		self.FlotterDict=StringVar()
		self.Flotter_Directory=Entry(self.frame,textvariable=self.FlotterDict,width=40)
		self.OtterDict=StringVar()
		self.Otter_Directory=Entry(self.frame,textvariable=self.OtterDict,width=40)
		self.TptpDict=StringVar()
		self.Tptp_Directory=Entry(self.frame,textvariable=self.TptpDict,width=40)
		self.ModelDict=StringVar()
		self.Model_Directory=Entry(self.frame,textvariable=self.ModelDict,width=40)
		
		label0 = Label(self.frame, text="Main:")
		label1 = Label(self.frame, text="SPASS-Flags:")
		label2 = Label(self.frame, text="Flotter-Flags:")
		label3 = Label(self.frame, text="Otter-Flags:")
		label4 = Label(self.frame, text="TPTP2X-Flags:")
		label5 = Label(self.frame, text="Models:")

		label0.grid(row=0,column=0,sticky="W")
		label1.grid(row=1,column=0,sticky="W")
		label2.grid(row=2,column=0,sticky="W")
		label3.grid(row=3,column=0,sticky="W")
		label4.grid(row=4,column=0,sticky="W")
		label5.grid(row=5,column=0,sticky="W")

		self.Main_Directory.grid(row=0,column=1,padx=10,pady=10)
		self.Spass_Directory.grid(row=1,column=1,padx=10,pady=10)
		self.Flotter_Directory.grid(row=2,column=1,padx=10,pady=10)
		self.Otter_Directory.grid(row=3,column=1,padx=10,pady=10)
		self.Tptp_Directory.grid(row=4,column=1,padx=10,pady=10)
		self.Model_Directory.grid(row=5,column=1,padx=10,pady=10)

		if os.path.exists("AutoMod.pref"):
			self.dirs=getPreferences().getDirectories()
			self.MainDict.set(self.dirs["mainDir"])
			self.SpassDict.set(self.dirs["spassDir"])
			self.FlotterDict.set(self.dirs["flotterDir"])
			self.OtterDict.set(self.dirs["otterDir"])
			self.TptpDict.set(self.dirs["tptpDir"])
			self.ModelDict.set(self.dirs["modelDir"])
			if os.path.exists(self.MainDict.get())==0:
				tkMessageBox.showerror("Directory","Main Directory does not exist - \n" + self.MainDict.get())
			if os.path.exists(self.SpassDict.get())==0:
				tkMessageBox.showerror("Directory","Directory for SPASS-Flags does not exist - \n" + self.SpassDict.get())
			if os.path.exists(self.FlotterDict.get())==0:
				tkMessageBox.showerror("Directory","Directory for Flotter-Flags does not exist - \n" + self.FlotterDict.get())
			if os.path.exists(self.OtterDict.get())==0:
				tkMessageBox.showerror("Directory","Directory for Otter-Flags does not exist - \n" + self.OtterDict.get())
			if os.path.exists(self.TptpDict.get())==0:
				tkMessageBox.showerror("Directory","Directory for TPTP-Flags does not exist - \n" + self.TptpDict.get())
			if os.path.exists(self.ModelDict.get())==0:
				tkMessageBox.showerror("Directory","Directory for Models does not exist - \n" + self.ModelDict.get())
		else:
			tkMessageBox.showerror("File","Preferences-File does not exist - \nAutoMod.pref")


	def quit(self):
		if os.path.exists(self.SpassDict.get())==0:
			tkMessageBox.showerror("Directory","Directory for SPASS-Flags does not exist - \n" + self.SpassDict.get())
		elif os.path.exists(self.MainDict.get())==0:
			tkMessageBox.showerror("Directory","Directory for Flotter-Flags does not exist - \n" + self.MainDict.get())
		elif os.path.exists(self.FlotterDict.get())==0:
			tkMessageBox.showerror("Directory","Directory for Flotter-Flags does not exist - \n" + self.FlotterDict.get())
		elif os.path.exists(self.OtterDict.get())==0:
			tkMessageBox.showerror("Directory","Directory for Otter-Flags does not exist - \n" + self.OtterDict.get())
		elif os.path.exists(self.TptpDict.get())==0:
			tkMessageBox.showerror("Directory","Directory for TPTP-Flags does not exist - \n" + self.TptpDict.get())
		elif os.path.exists(self.ModelDict.get())==0:
			tkMessageBox.showerror("Directory","Directory for Models does not exist - \n" + self.ModelDict.get())
		else:
			self.ret={"mainDir":"F","spassDir":"F","flotterDir":"F","otterDir":"F","tptpDir":"F","modelDir":"F"}
			try:
				f=open("AutoMod.pref")
				lines = f.readlines()
				f.close()
				numOfLines=len(lines)
			except:
				numOfLines=0
			f=open("AutoMod.pref","w")
			for i in range(numOfLines):
				y=string.split(lines[i])
				try:
					if y[0]=="Main":
						f.write("Main " + self.MainDict.get()+"\n")
						self.ret["mainDir"]=self.MainDict.get()
					if y[0]=="SPASS":
						f.write("SPASS " + self.SpassDict.get()+"\n")
						self.ret["spassDir"]=self.SpassDict.get()
					elif y[0]=="Flotter":
						f.write("Flotter " + self.FlotterDict.get()+"\n")
						self.ret["flotterDir"]=self.FlotterDict.get()
					elif y[0]=="Otter":
						f.write("Otter " + self.OtterDict.get()+"\n")
						self.ret["otterDir"]=self.OtterDict.get()
					elif y[0]=="TPTP":
						f.write("TPTP " + self.TptpDict.get()+"\n")
						self.ret["tptpDir"]=self.TptpDict.get()
					elif y[0]=="Model":
						f.write("Model " + self.ModelDict.get()+"\n")
						self.ret["modelDir"]=self.ModelDict.get()
					else:
						f.write(lines[i])
				except:
					pass
			f.write("\n")
			if self.ret["mainDir"]=="F":
				f.write("Main " + self.MainDict.get()+"\n")
				self.ret["mainDir"]=self.MainDict.get()
			if self.ret["spassDir"]=="F":
				f.write("SPASS " + self.SpassDict.get()+"\n")
				self.ret["spassDir"]=self.SpassDict.get()
			if self.ret["flotterDir"]=="F":
				f.write("Flotter " + self.FlotterDict.get()+"\n")
				self.ret["flotterDir"]=self.FlotterDict.get()
			if self.ret["otterDir"]=="F":
				f.write("Otter " + self.OtterDict.get()+"\n")
				self.ret["otterDir"]=self.OtterDict.get()
			if self.ret["tptpDir"]=="F":
				f.write("TPTP " + self.TptpDict.get()+"\n")
				self.ret["tptpDir"]=self.TptpDict.get()
			if self.ret["modelDir"]=="F":
				f.write("Model " + self.ModelDict.get()+"\n")
				self.ret["modelDir"]=self.ModelDict.get()
			f.close
			self.top.destroy()

	def show(self):
		self.top.deiconify()
		self.top.wait_window()
		return self.ret

class getPreferences:
	def getDirectories(self):
		f=open("AutoMod.pref")
		lines = f.readlines()
		f.close()
		x={}
		x["mainDir"]=""
		x["spassDir"]=""
		x["flotterDir"]=""
		x["otterDir"]=""
		x["tptpDir"]=""
		x["modelDir"]=""
		x["Error"]="F"
		numOfLines = len(lines)
		for i in range(numOfLines):
			y=string.split(lines[i])
			try:
				if y[0]=="Main":
					x["mainDir"]=y[1]
				if y[0]=="SPASS":
					x["spassDir"]=y[1]
				if y[0]=="Flotter":
					x["flotterDir"]=y[1]
				if y[0]=="Otter":
					x["otterDir"]=y[1]
				if y[0]=="TPTP":
					x["tptpDir"]=y[1]
				if y[0]=="Model":
					x["modelDir"]=y[1]
			except:
				pass
		if (x["mainDir"]=="" or x["spassDir"]=="" or x["flotterDir"]=="" or x["otterDir"]=="" or x["tptpDir"]=="" or x["modelDir"]==""):
			tkMessageBox.showerror("Preferences","Not all directories defined or error in Preferences-File - \nAutoMod.pref")
			x["Error"]="T"
		return x
