#!/usr/bin/python
import file
import sys
import os
import string
import glob
from Tkinter import *
from ScrolledText import ScrolledText
from FileDialog import LoadFileDialog, SaveFileDialog
import fedit
import tkMessageBox
from spaflags import SPASS_Flags
from cl_eval import Clause_Evaluation
from flogrp import Flotter
from floflags import *
from ottflags import *
from prefs import *
import outwin
from io import *
import subproc
from ask import ask
import askff
from tptp2x import *

class Tilt(Frame):
	"""Represents the main window."""


	def __init__(self, parent=None):
		"""Initialization of the dialog"""

		Frame.__init__(self, parent)
		self.master.title("TILT -- The Incredible Logic Tool "
				  "<Version 0.2>")
		self.parent = parent		# The parent (tk in our case)
		self.file = StringVar()		# The name of the current file
		self.file.set("")
		self._class = StringVar()    # The class of the current file
		self._class.set("")
		self.sat = StringVar()
		self.sat.set("")		# Is current file satisfiable?
		self.num=1		    # Number of formulas inserted 
						# with"Add Formula"
		self.numOfLines = 0		# number of lines in Text Area
		self.spass_flag_object="F"
		self.otter_flag_object="F"

		self.pack(expand=1,fill=BOTH)
		self.menubar = Frame(self, relief=RAISED, bd=2)
		self.menubar.pack(side=TOP, fill=X)
		self.makeMenu()
		self.makeWidgets()
		self.clear_editor()

		# size of user interface
		self.width=100
		self.height=40

# all necessary directories for the prolog, otter, spass etc..

#		self.dir = "/pd/mb/fwf/georg/tilt"
#						Starting directory for File
#						Open Dialog

                self.dir = "@tilt_inst@"
		                               # installation directory

		self.SPASS = "@spass@"
		self.OTTER2 = "@otter2@"
		self.SICSTUS = "@sicstus@"
		self.SWIPL = "@pl@"
		self.TPTP2X = self.dir + "/bin/tptp2X"

    	def makeMenu(self):
		# File menu
		fileButton=Menubutton(self.menubar,text="File",underline=0)
		fileButton.pack(side=LEFT)
		self.fileMenu=Menu(fileButton)
		self.fileMenu.add_command(label="New", command=self.new_file)
		self.fileMenu.add_command(label="Open...", command=self.open_file)
		self.fileMenu.add_command(label="Save...", command=self.save_file)
		self.fileMenu.add_command(label="Exit", command=self.quit_app)
		fileButton["menu"]=self.fileMenu

		# Edit menu
		editButton = Menubutton(self.menubar, text="Edit", underline=0)
		editButton.pack(side=LEFT)
		self.editMenu = Menu(editButton)
		self.editMenu.add_command(label="Add component", 
				command=self.add_comp)
		self.editMenu.add_command(label="Edit component",    
				 command=self.edit_curr_comp)
		self.editMenu.add_command(label="Remove component",
				 command=self.remove_curr_comp)
		editButton['menu'] = self.editMenu

		# Tools menu
		toolsButton = Menubutton(self.menubar, text="Tools", underline=0)
		toolsButton.pack(side=LEFT)

		self.toolsMenu = Menu(toolsButton)
		self.convertMenu=Menu(self.toolsMenu)
		self.convertMenu.add_command(label="TPTP to DFG", command=self.tptp2dfg)
		self.convertMenu.add_command(label="TPTP to Otter", command=self.tptp2otter)
		self.convertMenu.add_command(label="DFG to Otter")
		self.convertMenu.add_command(label="DFG to TPTP")
		self.convertMenu.add_command(label="DFG to CNF", command=self.dfg2cnf)
		self.convertMenu.add_command(label="Otter to TPTP")
		self.convertMenu.add_command(label="CNF to DFG")

		self.toolsMenu.add_cascade(label="Convert", menu=self.convertMenu)
		self.toolsMenu.add_command(label="Classify", command=self.do_classify)
		self.toolsMenu.add_separator()
		self.toolsMenu.add_command(label="Run SPASS", command=self.do_SPASS)
		self.toolsMenu.add_command(label="Run Otter", command=self.do_Otter)
		self.toolsMenu.add_separator()
		self.toolsMenu.add_command(label="Build model", command=self.build_model)
		self.toolsMenu.add_command(label="Evaluate clause", command=self.clause_eval)
		toolsButton['menu'] = self.toolsMenu

		# Set Flags menu
		flagButton = Menubutton(self.menubar, text="Set Flags", underline=0)
		flagButton.pack(side=LEFT)
		self.flagMenu = Menu(flagButton)
		self.flagMenu .add_command(label="SPASS", command=self.show_SPASS_Flags)
		self.flagMenu .add_command(label="Otter", command=self.show_Otter_Flags)
		flagButton['menu'] = self.flagMenu

		#Mode menu
		modeButton=Menubutton(self.menubar,text="Mode",underline=0)
		modeButton.pack(side=LEFT)
		self.mode=StringVar()
		self.modeMenu=Menu(modeButton)
		self.modeMenu.add_radiobutton(label="Automatic", variable=self.mode,command=self.activate_menu)
		self.modeMenu.add_radiobutton(label="Standard (Otter)", variable=self.mode, state="active",command=self.activate_menu)
		self.modeMenu.add_radiobutton(label="Experimental (SPASS)", variable=self.mode,command=self.activate_menu)
		self.modeMenu.add_radiobutton(label="Choose interactively", variable=self.mode,command=self.activate_menu)
		self.mode.set("Standard (Otter)")
		modeButton["menu"]=self.modeMenu
		
		# Preferences menu
		preferencesButton = Menubutton(self.menubar, text="Preferences", underline=0)
		preferencesButton.pack(side=LEFT)
		self.preferencesMenu = Menu(preferencesButton)
		self.preferencesMenu .add_command(label="Directory", command=self.set_directories)
		preferencesButton['menu'] = self.preferencesMenu

		self.SPASS_default=SPASS_Flags(self,"","","").show("GET")
		self.SPASS_act=self.SPASS_default
		self.Flotter_default=Flotter(self,"").show("GET")
		self.Otter_default=Otter_Flags(self,"","","").show("GET")
		self.Otter_act=self.Otter_default
		self.type="None"

	def activate_menu(self):
		if self.type=="None":
			self.fileMenu.entryconfig("Save...",state=DISABLED)
			self.editMenu.entryconfig("Add component",state=DISABLED)
			self.editMenu.entryconfig("Edit component",state=DISABLED)
			self.editMenu.entryconfig("Remove component",state=DISABLED)
			self.toolsMenu.entryconfig("Convert",state=DISABLED)
			self.toolsMenu.entryconfig("Classify",state=DISABLED)
			self.toolsMenu.entryconfig("Run SPASS",state=DISABLED)
			self.toolsMenu.entryconfig("Run Otter",state=DISABLED)
			self.toolsMenu.entryconfig("Build model",state=DISABLED)
			self.flagMenu.entryconfig("SPASS",state=DISABLED)
			self.flagMenu.entryconfig("Otter",state=DISABLED)
		else:
			self.fileMenu.entryconfig("Save...",state=NORMAL)
			self.editMenu.entryconfig("Add component",state=NORMAL)
			self.editMenu.entryconfig("Edit component",state=NORMAL)
			self.editMenu.entryconfig("Remove component",state=NORMAL)
			self.toolsMenu.entryconfig("Build model",state=NORMAL)

			if self.mode.get()=="Choose interactively":
				self.toolsMenu.entryconfig("Classify",state=NORMAL)
				self.flagMenu.entryconfig("SPASS",state=NORMAL)
				self.flagMenu.entryconfig("Otter",state=NORMAL)
				if self.type=="otter":
					self.toolsMenu.entryconfig("Run SPASS",state=DISABLED)
				else:
					self.toolsMenu.entryconfig("Run SPASS",state=NORMAL)
				if (self.type=="dfg" or self.type=="cnf"):
					self.toolsMenu.entryconfig("Run Otter",state=DISABLED)
				else:
					self.toolsMenu.entryconfig("Run Otter",state=NORMAL)
				self.toolsMenu.entryconfig("Convert",state=NORMAL)
			else:
				self.toolsMenu.entryconfig("Run SPASS",state=DISABLED)
				self.toolsMenu.entryconfig("Run Otter",state=DISABLED)
				self.flagMenu.entryconfig("SPASS",state=DISABLED)
				self.flagMenu.entryconfig("Otter",state=DISABLED)
				self.toolsMenu.entryconfig("Convert",state=DISABLED)
				self.toolsMenu.entryconfig("Classify",state=DISABLED)
			if self.type=="dfg":
				self.convertMenu.entryconfig("TPTP to DFG",state=DISABLED)
				self.convertMenu.entryconfig("TPTP to Otter",state=DISABLED)
				self.convertMenu.entryconfig("DFG to Otter",state=NORMAL)
				self.convertMenu.entryconfig("DFG to TPTP",state=NORMAL)
				self.convertMenu.entryconfig("DFG to CNF",state=NORMAL)
				self.convertMenu.entryconfig("Otter to TPTP",state=DISABLED)
				self.convertMenu.entryconfig("CNF to DFG",state=DISABLED)
			elif self.type=="cnf": 
				self.convertMenu.entryconfig("TPTP to DFG",state=DISABLED)
				self.convertMenu.entryconfig("TPTP to Otter",state=DISABLED)
				self.convertMenu.entryconfig("DFG to Otter",state=DISABLED)
				self.convertMenu.entryconfig("DFG to TPTP",state=DISABLED)
				self.convertMenu.entryconfig("DFG to CNF",state=DISABLED)
				self.convertMenu.entryconfig("Otter to TPTP",state=DISABLED)
				self.convertMenu.entryconfig("CNF to DFG",state=NORMAL)
			elif self.type=="otter": 
				self.convertMenu.entryconfig("TPTP to DFG",state=DISABLED)
				self.convertMenu.entryconfig("TPTP to Otter",state=DISABLED)
				self.convertMenu.entryconfig("DFG to Otter",state=DISABLED)
				self.convertMenu.entryconfig("DFG to TPTP",state=DISABLED)
				self.convertMenu.entryconfig("DFG to CNF",state=DISABLED)
				self.convertMenu.entryconfig("Otter to TPTP",state=NORMAL)
				self.convertMenu.entryconfig("CNF to DFG",state=DISABLED)
			else: 
				if self.mode.get()=="Choose interactively":
					self.toolsMenu.entryconfig("Classify",state=NORMAL)
				self.convertMenu.entryconfig("TPTP to DFG",state=NORMAL)
				self.convertMenu.entryconfig("TPTP to Otter",state=NORMAL)
				self.convertMenu.entryconfig("DFG to Otter",state=DISABLED)
				self.convertMenu.entryconfig("DFG to TPTP",state=DISABLED)
				self.convertMenu.entryconfig("DFG to CNF",state=DISABLED)
				self.convertMenu.entryconfig("Otter to TPTP",state=DISABLED)
				self.convertMenu.entryconfig("CNF to DFG",state=DISABLED)

			self.not_available()

	def not_available(self):
			self.convertMenu.entryconfig("DFG to Otter",state=DISABLED)
			self.convertMenu.entryconfig("DFG to TPTP",state=DISABLED)
			self.convertMenu.entryconfig("Otter to TPTP",state=DISABLED)
			self.convertMenu.entryconfig("CNF to DFG",state=DISABLED)

    	def makeWidgets(self):
		"""Creates the ScrolledText-Field, the button and the
		data-area (filename, class, satisfiability). The last
		part is delegated to self.fill_data_area()"""

		# set size of user interface
		#self.text_area = ScrolledText(self, width=70, height=20, relief="sunken")
		
		self.text_area = ScrolledText(self, width=100, height=40, relief="sunken")
		self.text_area.pack(expand=1, fill=BOTH, padx=2, pady=2)
		self.text_area.focus_set()

		# Die Text-Area wird vom FormulaEditor verwaltet
		self.file_editor = fedit.FileEditor(self.text_area)

		self.fill_data_area()
		self.data_area.pack(side=LEFT, expand=1, fill=X)


    	def fill_data_area(self):
		"""creates the data-area (filename, class, satisfiability)"""

		self.data_area = Frame(self, bd=2, relief = SUNKEN)

		self.label_filename = Label(self.data_area, 
				    textvariable=self.file)
		self.label_filename.pack(side=LEFT)

    	def getDirs(self):
		if os.path.exists("AutoMod.pref"):
		    	self.dirs=getPreferences().getDirectories()
		    	if self.dirs["Error"]=="F":
				if (os.path.exists(self.dirs["mainDir"]) and 
				   os.path.exists(self.dirs["spassDir"]) and 
				   os.path.exists(self.dirs["flotterDir"]) and 
				   os.path.exists(self.dirs["otterDir"]) and 
				   os.path.exists(self.dirs["modelDir"]) and
				   os.path.exists(self.dirs["tptpDir"])):
				    	self.setDirs()
				else:
			    		self.dirs=SetDirectories(self).show()
			   		self.setDirs()
			else:
				self.dirs=SetDirectories(self).show()
				self.setDirs()
		else:
		    	self.dirs=SetDirectories(self).show()
		    	self.setDirs()

    	def setDirs(self):
		self.ClausesDir=self.dirs["modelDir"]
		self.MainDir=self.dirs["mainDir"]
		self.SpassDir=self.dirs["spassDir"]
		self.FlotterDir=self.dirs["flotterDir"]
		self.OtterDir=self.dirs["otterDir"]
		self.TptpDir=self.dirs["tptpDir"]
		self.ModelDir=self.dirs["modelDir"]

    	def show_file(self):
		"""Presents the contents of self.file in the Text Area"""
		if self.file.get() == "":
		    	pass
		else:
		    	filename = self.file.get()
		    	f = open(filename)
		    	lines = f.readlines()
		    	f.close()
		    	self.file_editor.show_text(lines, self.type)

    	def do_nothing(self) : 
		"""Used for all functions which are not yet implemented"""
		pass

    	def new_file(self):
		dlg = askff.AskFileFormatDialog(self)
		dlg.show()
		self.type = dlg.get_type()
		self.clear_editor()

    	def clear_editor(self):
		self.getDirs()
		self.file_editor.clear_contents()
		self.activate_menu()

    	def open_file(self):
		"""Opens a file using the file dialog. Clears the
		contents of the Text Area (using self.clear_editor())
		and refills it with the contents of the file (using
		self.show_file())."""

		self.getDirs()
		fd = LoadFileDialog(self)
		filename = fd.go(".", "*.*", "", 1)
		if filename != None:
		    	self.file.set(filename)
		    	self._class.set("")
		    	self.clear_editor()
		    	typestring = string.splitfields(filename, ".")[-1]
		    	if typestring == "in":
		    		self.type = "otter"
			elif typestring == "cnf":
			    self.type = "cnf"
			elif typestring == "dfg":
			    self.type = "dfg"
			elif typestring == "p":
			    if self.contains_clauses(filename):
				self.type = "tptpc"
			    else:
				self.type = "tptpf"
		    	self.clear_editor()
			self.show_file()

	def contains_clauses(self,  filename):
	    f = open(filename)
	    lines = f.readlines()
	    
	    for line in lines:
		if string.find(line, "[")>-1:
		    return 1
	    return 0

	def save_file(self):
		fd=SaveFileDialog(self)
		filename = fd.go(".","*.*", "", 1)
		if filename<>None:
		    	# file_comp = string.split(filename)
			# GM seems to be bug
		    	has_ext_string = string.splitfields(filename, ".")[-1]
			if self.type=="otter":
			    des_ext="in"
			elif self.type=="dfg":
			    des_ext="dfg"
			elif self.type=="cnf":
			    des_ext="cnf"
			elif self.type=="tptpc":
			    des_ext="p"
			elif self.type=="tptpf":
			    des_ext="p"
		    	#if file_comp[-1] != self.type:
			#	tkMessageBox.showerror("Wrong filename", "The filename must correspond to the type!")
		        #else:
			#self.do_save(filename)
			if has_ext_string != des_ext:
			    tkMessageBox.showerror("Wrong filename", "The filename must correspond to the type!")
			else:
			    self.do_save(filename)


	def do_save(self,fname):
		f=open(fname,"w")
		j0=string.splitfields(self.text_area.index("end"),".")
		j=eval(j0[0])
		for i in range(1,j):
		    	f.write(self.text_area.get(str(i)+".0",
		    	str(self.text_area.index(str(i)+".0 lineend")))+"\n")
		f.write("\n")
		f.close()

    	def classify(self, filename):
		"""Calls the classifier and checks whether there exists
		a file *.pvd.p or *.pvdeq.p. Fills the "Class"-Field
		accordingly"""
		components = string.splitfields(filename, ".")
		pvd = components[:-1]+["pvd"]+components[-1:]
		pvdeq = components[:-1]+["pvdeq"]+components[-1:]
		#print pvd
		#print pvdeq
		try:
		    os.system("rm -f " + string.joinfields(pvd, "."))
		    os.system("rm -f " + string.joinfields(pvdeq, "."))
		except:
		    pass

		command = 'echo "consult(\'' + self.dir + '/classify/classify.pl\'). ' + \
			  'classify(\'' + filename + '\', _, _). halt. " | ' + self.SWIPL + ' 2>/dev/null'
		os.system(command)
		components = string.splitfields(filename, ".")
		pvd = components[:-1]+["pvd"]+components[-1:]
		pvdeq = components[:-1]+["pvdeq"]+components[-1:]
		#print pvd
		#print pvdeq
		if glob.glob(string.joinfields(pvd, ".")):
		    	return "PVD"
		elif glob.glob(string.joinfields(pvdeq, ".")):
		    	return "PVD_g^="
		else:
		    	return "unknown"

	def do_classify(self):
		f0="/tmp/tilt_CLASS"
		f=f0+".p"
		self.do_save(f)
		theclass = self.classify(f)
	    	win = outwin.OutputWindow(self, "Classify")
		if theclass == "PVD":
		    	f=f0+".pvd.p"
		elif theclass == "PVD_g^=":
			f=f0+".pvdeq.p"
		command = "cat " + f
		win.show(command)

	def clause_eval(self):
		self.getDirs()
		Clause_Evaluation(self,self.ModelDir,self.ClausesDir,self.dir,self.SICSTUS).show()	
	
	def build_model(self):
		if self.mode.get() == 'Experimental (SPASS)':
			self.classify_build_model_with_SPASS("default")
		elif self.mode.get() == 'Standard (Otter)':
			self.classify_build_model_with_Otter()
		elif self.mode.get()=="Choose interactively":
			if tkMessageBox.askyesno("Use","Use the standard Algorithm from Fermller/Leitsch? (no means use SPASS)"):
				self.classify_build_model_with_Otter()
			else:
				tkMessageBox.showinfo("Flags","Using Flag-Settings")
				self.classify_build_model_with_SPASS("with_actual_flags")
		else:
			f="/tmp/tilt_CLASS"
			f=f+".p"
			self.do_save(f)
			theclass = self.classify(f)
			if (theclass == "PVD" or theclass == "PVD_g^="):
				self.build_model_with_Otter(theclass)
			else:
				self.build_model_with_SPASS(theclass,"default")


#
# methods to deal with the model building and extraction
# 

#
# build_model_with_Otter_extraction
#         extraction of finite model and final arm
#
	def build_model_with_Otter_extraction(self,basename):
			f_p=basename+".p"                         #Orginal filename
			f_p="'"+f_p+"'"
	                f_ren_arm=basename+".ren.arm"             #NAME of not yet (re)renamed
                                                                  # ARM
	                f_ren_arm="'"+f_ren_arm+"'"

			f_set=basename + ".ren"                   #NAME of Setting file
			f_set= "'" + f_set + "'"
			
			f=""
			if self.file.get()<>"":
			    y=string.splitfields(self.file.get(),"/")
			    l=len(y)
			    x=string.splitfields(y[l-1],".")
			    l=len(x)
			    for i in range(l-1):
				f=f+x[i]+"."
			    l=len(f)
			    f=f[0:l-1]+"-"
			else:
			    f="model"

			n=NewFileName().get(self.ModelDir,f,"fin")
			f_fin=self.ModelDir
			fl=len(f_fin)
			if f_fin[fl-1]<>"/":
			    f_fin=f_fin+"/"
			f_fin="'" + f_fin + n + "'"              #NAME VOM ENDGUELTIGEN ARM-FILE
		
			n=NewFileName().get(self.ModelDir,f,"arm")
			f_arm=self.ModelDir
			fl=len(f_arm)
			if f_arm[fl-1]<>"/":
			    f_arm=f_arm+"/"
			f_arm="'" + f_arm + n + "'"              #NAME VOM ENDGUELTIGEN ARM-FILE
					
			command = \
				"echo \" consult('" + self.dir + "/finmodel/fin.pl'), " + \
				"finite_model(tptp," +f_ren_arm +"," +f_p+ ", " + \
				f_set +"," +f_fin+ "," + f_arm+ "), halt. \" | " + \
				self.SICSTUS +" 2>/dev/null"
			win = outwin.OutputWindow(self, "Finite Model Building")
			win.show(command)
			win = outwin.OutputWindow(self, "Final ARM")
			command = "cat " + f_arm
			win.show(command)
#
# build_model_with_Otter
#            build model from using otter2 assuming that
#            the tptp file has already classified
#
	def build_model_with_Otter(self,theclass):
			f0="/tmp/tilt_CLASS"
			if theclass == "PVD":
			        f_pvd=f0+".pvd.p"
				f_pvd+"'"+f_pvd+"'"
				command = "echo \" consult('" + self.dir + "/standard/run.pl'), " + \
				      	"standardMB(" + f_pvd + ", pvd), halt. \" | " + \
					self.SICSTUS + " 2>/dev/null"
			elif theclass == "PVD_g^=":
			        f_pvdeq=f0+".pvdeq.p"
				f_pvdeq="'"+f_pvdeq+"'"
			    	command = "echo \" consult('" + self.dir + "/standard/run.pl'), " + \
					"standardMB(" + f_pvdeq + ", pvdeq), halt. \" | " + \
					self.SICSTUS + " 2>/dev/null"
			else:
			    	command = None
			    	tkMessageBox.showinfo("Unknown class", "Class is unknown!")
			win = outwin.OutputWindow(self, "Building Model")
			win.show(command)
			self.build_model_with_Otter_extraction(f0)

#
# classify_build_model_with_Otter
#            build model with otter2 
#            after classifcation
#
	def classify_build_model_with_Otter(self):
	                f0="/tmp/tilt_ARMcomput"
			f_p=f0+".p"
			self.do_save(f_p)
			theclass = self.classify(f_p)
			if theclass == "PVD":
			        f_pvd=f0+".pvd.p"
				f_pvd="'"+f_pvd+"'"
				command = "echo \" consult('" + self.dir + "/standard/run.pl'), " + \
				      	"standardMB(" + f_pvd + ", pvd), halt. \" | " + \
					self.SICSTUS +" 2>/dev/null"
			elif theclass == "PVD_g^=":
			        f_pvdeq=f0+".pvdeq.p"
				f_pvdeq="'"+f_pvdeq+"'"
			    	command = "echo \" consult('" + self.dir + "/standard/run.pl'), " + \
					"standardMB(" + f_pvdeq + ", pvdeq), halt. \" | " + \
					self.SICSTUS +" 2>/dev/null"
			else:
			    	command = None
			    	tkMessageBox.showinfo("Unknown class", "Class is unknown!")
			win = outwin.OutputWindow(self, "Building Model")
			win.show(command)
			self.build_model_with_Otter_extraction(f0)

#
# build_model_with_SPASS_extraction
#         extraction of finite model and final arm
#
	def build_model_with_SPASS_extraction(self,basename,flag):
			f_ren_arm = basename + ".ren.arm"                #NAME of not yet (re)renamed
			                                                 # ARM
			f_ren_arm = "'" + f_ren_arm + "'"
			f_set=basename + ".ren"                          #NAME of Setting file
			f_set= "'" + f_set + "'"

			f=""
			if self.file.get()<>"":
			    y=string.splitfields(self.file.get(),"/")
			    l=len(y)
			    x=string.splitfields(y[l-1],".")
			    l=len(x)
			    for i in range(l-1):
				f=f+x[i]+"."
				l=len(f)
				f=f[0:l-1]+"-"
			else:
			    f="model"

			n=NewFileName().get(self.ModelDir,f,"fin")
			f_fin=self.ModelDir
			fl=len(f_fin)
			if f_fin[fl-1]<>"/":
			       	f_fin=f_fin+"/"
			f_fin="'" + f_fin + n + "'"              #NAME VOM ENDGUELTIGEN ARM-FILE
		
			n=NewFileName().get(self.ModelDir,f,"arm")
			f_arm=self.ModelDir
			fl=len(f_arm)
			if f_arm[fl-1]<>"/":
			       	f_arm=f_arm+"/"
			f_arm="'" + f_arm + n + "'"              #NAME VOM ENDGUELTIGEN ARM-FILE
					
			# GM Aufruf von finite_model 
			if flag=="cnf":
			    print flag
			    f_cnf=basename+".cnf"
			    f_cnf = "'" + f_cnf + "'"
			    command = \
			       	    "echo \" consult('" + self.dir + "/finmodel/fin.pl'), " + \
				    "finite_model(cnf,"+ f_ren_arm +"," + f_cnf + ",[]," + \
				    f_fin + "," + f_arm + "), halt. \" | " + \
				    self.SICSTUS +" 2>/dev/null"
			elif flag=="tptp":
			    print flag
			    f_tptp=basename+".p"
			    f_tptp = "'" + f_tptp + "'"
			    command = \
				     "echo \" consult('" +self.dir + "/finmodel/fin.pl'), " + \
				     "finite_model(tptp,"+ f_ren_arm +"," + f_tptp + "," + \
				     f_set + "," + f_fin + "," + f_arm + "), halt.\" | " + \
				     self.SICSTUS +" 2>/dev/null"
			else:
			    tkMessageBox.showinfo("model","Please use TPTP or DFG format")

			FINoutputWindow = outwin.OutputWindow(self, "Finite Model Building")
			FINoutputWindow.show(command)
				
			command = "cat " + f_arm 
			ARMoutputWindow = outwin.OutputWindow(self, "Final ARM")
			ARMoutputWindow.show(command)

#
# build_model_with_SPASS
#            build model from using spass assuming that
#            the tptp file has already classified
#

	def build_model_with_SPASS(self,theclass,value):
			f0="/tmp/tilt_CLASS"
			f_cnf=f0 = ".cnf"
			
			if theclass=="PVD":
			    f_pvd=f0+".pvd.p"
			    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_pvd + ">"+f_cnf)
			elif theclass=="PVD_g^=":
			    f_pvdeq=f0+".pvdeq.p"
			    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_pvdeq + ">"+f_cnf)
			else:    
			    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_tptp + ">"+f_cnf)
			if value=="default":
			    FlagIO().FinalFile2_SPASS(f_cnf,self.SPASS_default,self.Flotter_default)
			else:
			    FlagIO().FinalFile2_SPASS(f_cnf,self.SPASS_act,self.Flotter_default)
			command = self.SPASS + " " + f_cnf +"\n"
	    		outputWindow = outwin.OutputWindow(self, 
				"Building Model using SPASS")
			outputWindow.show(command)
			OK=0
			j0=string.splitfields(outputWindow.op_area.index("end"),".")
			j=eval(j0[0])
			t=range(1,j)
			t.reverse()
			empty=1
			for i in t:
				x=outputWindow.op_area.get(str(i)+".0",str(outputWindow.op_area.index(str(i)+".0 lineend")))
				if string.find(x,"Completion printed to:")<>-1:
						OK=1
						break
				if (empty==1 and string.join(string.split(x))<>""):
					empty=0
			if OK==1:
			    f_model=f_cnf+".model"
			    f_model="'" + f_model + "'"
			    f_ren_arm=f0+".ren.arm"
			    f_ren_arm="'"+f_ren_arm+"'"
			    command = \
			        "echo \"consult('"+ self.dir + "/exper/elimneg.pl')," +\
				 "experMB("+f_model+", "+f_ren_arm + "), halt. \" | " + \
				 self.SICSTUS +" 2>/dev/null"
			    os.popen(command)
			    self.build_model_with_SPASS_extraction(f0,"tptp")			
			elif empty==1:
			    tkMessageBox.showinfo("model","nothing to build model on")
			    outputWindow.top.destroy()
			else:
			    tkMessageBox.showinfo("model","Problem was unsatisfiable")

#
# classify_build_model_with_SPASS
#       build model with spass
#       after classifcation
#
	def classify_build_model_with_SPASS(self,value):
	# GM flag is either "cnf" or "tptp", depending on the 
	# original filename, used for finite_model/6                
	                f0="/tmp/tilt_ARMcomput"	
			if self.type=="dfg":
				flag="cnf"
				f_dfg=f0+".dfg"
				f_cnf=f0+".cnf"
				self.do_save(f_dfg)
				os.popen(self.SPASS + " -Flotter -PStatistic=0 "+ f_dfg + ">" + f_cnf)
			if self.type=="cnf":
				flag="cnf"
				f_cnf=f0+".cnf"
				self.do_save(f_cnf)
			if self.type=="otter":
				f_otter=f0+".in"
				self.do_save(f_otter)
				# GM nothing is done with an otter file
			if self.type=="tptpf":
				flag="tptp"
				f_tptp=f0+".p"
				self.do_save(f_tptp)
				f_cnf=f0+".dfg"
				# GM Neu Aufruf von classify
				theclass = self.classify(f_tptp)
				print theclass
				if theclass=="PVD":
				    f_pvd=f0+".pvd.p"
				    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_pvd + ">"+f_cnf)
				elif theclass=="PVD_g^=":
				    f_pvdeq=f0+".pvdeq.p"
				    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_pvdeq + ">"+f_cnf)
				else:    
				    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_tptp + ">"+f_cnf)
		        if self.type=="tptpc":
			        flag="tptp"
			        f_tptp=f0+".p"
			        self.do_save(f_tptp)
				f_cnf=f0+".cnf"
				# GM Neu Aufruf von classify
				theclass = self.classify(f_tptp)
				print theclass
				if theclass=="PVD":
				    f_pvd=f0+".pvd.p"
				    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_pvd + ">"+f_cnf)
				elif theclass=="PVD_g^=":
				    f_pvdeq=f0+".pvdeq.p"
				    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_pvdeq + ">"+f_cnf)
				else:    
				    os.popen(self.TPTP2X + " -q2  -fdfg -d'-' " + f_tptp + ">"+f_cnf)
			if value=="default":
			    FlagIO().FinalFile2_SPASS(f_cnf,self.SPASS_default,self.Flotter_default)
			else:
			    FlagIO().FinalFile2_SPASS(f_cnf,self.SPASS_act,self.Flotter_default)
			command = self.SPASS + " " + f_cnf +"\n"
	    		outputWindow = outwin.OutputWindow(self, 
				"Building Model using SPASS")
			outputWindow.show(command)
			OK=0
			j0=string.splitfields(outputWindow.op_area.index("end"),".")
			j=eval(j0[0])
			t=range(1,j)
			t.reverse()
			empty=1
			for i in t:
				x=outputWindow.op_area.get(str(i)+".0",str(outputWindow.op_area.index(str(i)+".0 lineend")))
				if string.find(x,"Completion printed to:")<>-1:
						OK=1
						break
				if (empty==1 and string.join(string.split(x))<>""):
					empty=0
			if OK==1:
			    f_model=f_cnf+".model"
			    f_model="'" + f_model + "'"
			    f_ren_arm=f0+".ren.arm"
			    f_ren_arm="'"+f_ren_arm+"'"
			    command = \
			        "echo \"consult('"+ self.dir + "/exper/elimneg.pl')," +\
				 "experMB("+f_model+", "+f_ren_arm + "), halt. \" | " + \
				 self.SICSTUS +" 2>/dev/null"
			    os.popen(command)
			    self.build_model_with_SPASS_extraction(f0,flag)			
			elif empty==1:
				tkMessageBox.showinfo("model","nothing to build model on")
				outputWindow.top.destroy()
			else:
				tkMessageBox.showinfo("model","Problem was unsatisfiable")


    	def dfg2cnf(self):
		x=Flotter(self,self.FlotterDir).show("SHOW")
		print x
		if x["Cancel"]=="F":
		    	self.do_save("SPASS_Out.cnf")
		    	FlagIO().FinalFile2_SPASS("SPASS_Out.cnf",{},x)
		    	self.tmp=outwin.OutputWindow(self, "DFG 2 CNF Output")
		    	self.tmp.show(self.SPASS + " SPASS_Out.cnf")
		    	p = os.popen(self.SPASS + " SPASS_Out.cnf")

    	def tptp2otter(self):
		x=TPTP2X(self,"Otter",self.TptpDir).show()
		self.tptp2X("Otter",x)

    	def tptp2dfg(self):
		x=TPTP2X(self,"Dfg",self.TptpDir).show()
		self.tptp2X("Dfg",x)

    	def tptp2X(self,name,tptp):
		if tptp<>"CANCEL":
		    	self.do_save("TPTP2X.p")
		    	conv=string.lower(name)
		    	tptp=tptp + " -f" + conv + " -d'-' TPTP2X.p"
		    	print tptp
		    	t="TPTP 2 " + name + "Output"
		    	self.tmp=outwin.OutputWindow(self, t)
		    	self.tmp.show(tptp)

	def set_directories(self): 
		self.dirs=SetDirectories(self).show()
		self.setDirs()

	def show_SPASS_Flags(self):
		if self.spass_flag_object=="F":
			self.spass_flag_object="T"
			x=SPASS_Flags(self,self.SpassDir,self.SPASS_default,self.SPASS_act).show("SHOW")
			if x["Cancel"]=="F":
				self.SPASS_act=x
			self.spass_flag_object="F"
		else:
			tkMessageBox.showinfo("Flag-Setting","Window for SPASS-Flag-Setting already open")
			pass

    	def show_Otter_Flags(self):
		if self.otter_flag_object=="F":
		    	self.otter_flag_object="T"
		    	x=Otter_Flags(self,self.OtterDir,self.Otter_default,self.Otter_act).show("SHOW")
		    	if x["Cancel"]=="F":
				self.Otter_act=x
		    	self.otter_flag_object="F"
		else:
		   	tkMessageBox.showinfo("Flag-Setting","Window for Otter-Flag-Setting already open")

	def do_SPASS(self):
		f0="Do_SPASS_on_this"
		f=f0+".dfg"
		if self.type=="dfg":
			self.do_save(f)
		elif self.type=="cnf":
			f=f0+".cnf"
			self.do_save(f)
		elif self.type=="tptpf":
			f1=f0+".p"
			self.do_save(f1)
			os.popen("tptp2X -q2 -tclausify:tptp -fdfg -d'-' " + f1 + ">"+f)
		elif self.type=="tptpc":
			f1=f0+".p"
			self.do_save(f1)
			os.popen("tptp2X -q2 -fdfg -d'-' " + f1 + ">"+f)
		FlagIO().FinalFile2_SPASS(f,self.SPASS_act,self.Flotter_default)
		self.tmp=outwin.OutputWindow(self, "SPASS Output")
		self.tmp.show(self.SPASS + " " + f)

    	def do_Otter(self):
		f0="Do_Otter_on_this"
		f=f0+".in"
		if self.type=="otter":
			self.do_save(f)
		if self.type=="tptpf":
			f1=f0+".p"
			self.do_save(f1)
			os.popen(self.TPTP2X + " -q2 -tclausify:otter -fotter -d'-' " + f1 + ">"+f)
		if self.type=="tptpc":
			f1=f0+".p"
			self.do_save(f1)
			os.popen(self.TPTP2X + " -q2 -fotter -d'-' " + f1 + ">"+f)
		FlagIO().FinalFile2_Otter(f,self.Otter_act)
		self.tmp=outwin.OutputWindow(self, "Otter Output")
		self.tmp.show(self.OTTER2 + "<" +f)

	def quit_app(self):
		"""Quits the application and python"""

		# Delete temporary files
		os.system("rm -f /tmp/tilt_CLASS*")
		os.system("rm -f /tmp/tilt_ARMcomput*")
		raise SystemExit		    

    	def add_comp(self):
		self.file_editor.add_component()

    	def edit_curr_comp(self):
		self.file_editor.edit_component()

    	def remove_curr_comp(self):
		self.file_editor.remove_component()

tk = Tk()
Tilt(tk).mainloop()

